-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 34 to version 35
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- ivyTeam AG, Alpenstrasse 9, 6304 Zug
-- ---------------------------------------------------------------------------------

-- Drop views which depend on changed tables
DROP VIEW IWA_TaskQuery
GO


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_UserDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_TaskDeleteTrigger
GO

-- Create new added tables
CREATE TABLE IWA_UserLocation
(
  UserLocationId BIGINT NOT NULL,
  UserId BIGINT NOT NULL,
  "Type" VARCHAR(200) NOT NULL,
  Note VARCHAR(2000) NOT NULL,
  Name VARCHAR(200) NOT NULL,
  Address VARCHAR(200) NOT NULL,
  Latitude DECIMAL(10, 8) NOT NULL,
  Longitude DECIMAL(11, 8) NOT NULL,
  Altitude DECIMAL(8, 3) NOT NULL,
  AccuracyHorizontal DECIMAL(8, 3) NULL,
  AccuracyVertical DECIMAL(8, 3) NULL,
  Speed DECIMAL(8, 3) NULL,
  Bearing DECIMAL(6, 3) NULL,
  LocationTimestamp DATETIME NULL,
  PRIMARY KEY (UserLocationId)
)
GO

CREATE TABLE IWA_TaskLocation
(
  TaskLocationId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL,
  "Type" VARCHAR(200) NOT NULL,
  Note VARCHAR(2000) NOT NULL,
  Name VARCHAR(200) NOT NULL,
  Address VARCHAR(200) NOT NULL,
  Latitude DECIMAL(10, 8) NOT NULL,
  Longitude DECIMAL(11, 8) NOT NULL,
  Altitude DECIMAL(8, 3) NOT NULL,
  AccuracyHorizontal DECIMAL(8, 3) NULL,
  AccuracyVertical DECIMAL(8, 3) NULL,
  Speed DECIMAL(8, 3) NULL,
  Bearing DECIMAL(6, 3) NULL,
  LocationTimestamp DATETIME NULL,
  PRIMARY KEY (TaskLocationId)
)
GO


-- Changed columns of table IWA_Application
ALTER TABLE IWA_Application ALTER COLUMN OwnerPassword VARCHAR(200) NOT NULL
GO
ALTER TABLE IWA_Application ALTER COLUMN DownloadPassword VARCHAR(200) NULL
GO


-- Changed columns of table IWA_ExternalNamingAndDirectory
ALTER TABLE IWA_ExternalNamingAndDirectory ALTER COLUMN UserPassword VARCHAR(200) NULL
GO


-- Changed columns of table IWA_ExternalDatabase
ALTER TABLE IWA_ExternalDatabase ALTER COLUMN UserPassword VARCHAR(200) NULL
GO


-- Changed columns of table IWA_User
ALTER TABLE IWA_User ALTER COLUMN UserPassword VARCHAR(200) NOT NULL
GO


-- Added columns of table IWA_Task
ALTER TABLE IWA_Task ADD
  IsOffline BIT NOT NULL DEFAULT 0
GO

-- Create new indexes of table IWA_Role
CREATE INDEX IWA_Role_ExternalSecurityNameIndex
ON IWA_Role (ApplicationId, ExternalSecurityName)
GO


-- Create new indexes of table IWA_User
CREATE INDEX IWA_User_ExternalSecurityNameIndex
ON IWA_User (ApplicationId, ExternalSecurityName)
GO


-- Create new indexes of table IWA_Case
CREATE INDEX IWA_Case_NameIndex
ON IWA_Case (Name)
GO

CREATE INDEX IWA_Case_CustVarCharFld1Idx
ON IWA_Case (CustomVarCharField1)
GO

CREATE INDEX IWA_Case_CustVarCharFld2Idx
ON IWA_Case (CustomVarCharField2)
GO

CREATE INDEX IWA_Case_CustVarCharFld3Idx
ON IWA_Case (CustomVarCharField3)
GO

CREATE INDEX IWA_Case_CustVarCharFld4Idx
ON IWA_Case (CustomVarCharField4)
GO

CREATE INDEX IWA_Case_CustVarCharFld5Idx
ON IWA_Case (CustomVarCharField5)
GO

CREATE INDEX IWA_Case_CustDecimalFld1Idx
ON IWA_Case (CustomDecimalField1)
GO

CREATE INDEX IWA_Case_CustDecimalFld2Idx
ON IWA_Case (CustomDecimalField2)
GO

CREATE INDEX IWA_Case_CustDecimalFld3Idx
ON IWA_Case (CustomDecimalField3)
GO

CREATE INDEX IWA_Case_CustDecimalFld4Idx
ON IWA_Case (CustomDecimalField4)
GO

CREATE INDEX IWA_Case_CustDecimalFld5Idx
ON IWA_Case (CustomDecimalField5)
GO

CREATE INDEX IWA_Case_CustTimestmpFld1Idx
ON IWA_Case (CustomTimestampField1)
GO

CREATE INDEX IWA_Case_CustTimestmpFld2Idx
ON IWA_Case (CustomTimestampField2)
GO

CREATE INDEX IWA_Case_CustTimestmpFld3Idx
ON IWA_Case (CustomTimestampField3)
GO

CREATE INDEX IWA_Case_CustTimestmpFld4Idx
ON IWA_Case (CustomTimestampField4)
GO

CREATE INDEX IWA_Case_CustTimestmpFld5Idx
ON IWA_Case (CustomTimestampField5)
GO


-- Create new indexes of table IWA_Task
CREATE INDEX IWA_Task_NameIndex
ON IWA_Task (Name)
GO

CREATE INDEX IWA_Task_CustVarCharFld1Idx
ON IWA_Task (CustomVarCharField1)
GO

CREATE INDEX IWA_Task_CustVarCharFld2Idx
ON IWA_Task (CustomVarCharField2)
GO

CREATE INDEX IWA_Task_CustVarCharFld3Idx
ON IWA_Task (CustomVarCharField3)
GO

CREATE INDEX IWA_Task_CustVarCharFld4Idx
ON IWA_Task (CustomVarCharField4)
GO

CREATE INDEX IWA_Task_CustVarCharFld5Idx
ON IWA_Task (CustomVarCharField5)
GO

CREATE INDEX IWA_Task_CustDecimalFld1Idx
ON IWA_Task (CustomDecimalField1)
GO

CREATE INDEX IWA_Task_CustDecimalFld2Idx
ON IWA_Task (CustomDecimalField2)
GO

CREATE INDEX IWA_Task_CustDecimalFld3Idx
ON IWA_Task (CustomDecimalField3)
GO

CREATE INDEX IWA_Task_CustDecimalFld4Idx
ON IWA_Task (CustomDecimalField4)
GO

CREATE INDEX IWA_Task_CustDecimalFld5Idx
ON IWA_Task (CustomDecimalField5)
GO

CREATE INDEX IWA_Task_CustTimestmpFld1Idx
ON IWA_Task (CustomTimestampField1)
GO

CREATE INDEX IWA_Task_CustTimestmpFld2Idx
ON IWA_Task (CustomTimestampField2)
GO

CREATE INDEX IWA_Task_CustTimestmpFld3Idx
ON IWA_Task (CustomTimestampField3)
GO

CREATE INDEX IWA_Task_CustTimestmpFld4Idx
ON IWA_Task (CustomTimestampField4)
GO

CREATE INDEX IWA_Task_CustTimestmpFld5Idx
ON IWA_Task (CustomTimestampField5)
GO


-- Create new indexes of table IWA_EventLogStatus
CREATE INDEX IWA_EventLogStatus_StateEventLogIdIndex
ON IWA_EventLogStatus (Status, EventLogId)
GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_UserDeleteTrigger
  ON IWA_User FOR DELETE AS

  UPDATE IWA_Task  SET IWA_Task.State=9, IWA_Task.FailedTimeoutTimestamp=NULL, IWA_Task.WorkerUserId=NULL, IWA_Task.WorkerUserName=NULL
  FROM IWA_Task, deleted
  WHERE ((IWA_Task.ActivatorUserId = deleted.UserId AND IWA_Task.IsExpired = 0) OR (IWA_Task.ExpiryActivatorUserId = deleted.UserId AND IWA_Task.IsExpired = 1)) AND (IWA_Task."State" = 3 OR IWA_Task."State" = 4 OR IWA_Task."State" = 8 OR IWA_Task."State" = 10)

  UPDATE IWA_Task  SET IWA_Task.State=4, IWA_Task.WorkerUserName=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.WorkerUserId = deleted.UserId AND IWA_Task."State" = 8

  DELETE IWA_UserRole FROM IWA_UserRole, deleted
  WHERE IWA_UserRole.UserId = deleted.UserId

  DELETE IWA_UserProperty FROM IWA_UserProperty, deleted
  WHERE IWA_UserProperty.UserId = deleted.UserId

  DELETE IWA_RichDialogUserContext FROM IWA_RichDialogUserContext, deleted
  WHERE IWA_RichDialogUserContext.UserId = deleted.UserId

  DELETE IWA_UserAbsence FROM IWA_UserAbsence, deleted
  WHERE IWA_UserAbsence.UserId = deleted.UserId

  DELETE IWA_UserSubstitute FROM IWA_UserSubstitute, deleted
  WHERE IWA_UserSubstitute.UserId = deleted.UserId

  DELETE IWA_UserSubstitute FROM IWA_UserSubstitute, deleted
  WHERE IWA_UserSubstitute.SubstituteUserId = deleted.UserId

  UPDATE IWA_StartElement  SET IWA_StartElement.ActivatorUserId=NULL
  FROM IWA_StartElement, deleted
  WHERE IWA_StartElement.ActivatorUserId = deleted.UserId

  UPDATE IWA_Case  SET IWA_Case.CreatorUserId=NULL
  FROM IWA_Case, deleted
  WHERE IWA_Case.CreatorUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.WorkerUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.WorkerUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.ActivatorUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.ActivatorUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.ExpiryActivatorUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.ExpiryActivatorUserId = deleted.UserId

  UPDATE IWA_WorkflowEvent  SET IWA_WorkflowEvent.UserId=NULL
  FROM IWA_WorkflowEvent, deleted
  WHERE IWA_WorkflowEvent.UserId = deleted.UserId

  UPDATE IWA_Note  SET IWA_Note.UserId=NULL
  FROM IWA_Note, deleted
  WHERE IWA_Note.UserId = deleted.UserId

  DELETE IWA_UserLocation FROM IWA_UserLocation, deleted
  WHERE IWA_UserLocation.UserId = deleted.UserId

  UPDATE IWA_PageArchive  SET IWA_PageArchive.UserId=NULL
  FROM IWA_PageArchive, deleted
  WHERE IWA_PageArchive.UserId = deleted.UserId

  UPDATE IWA_SecurityDescriptor  SET IWA_SecurityDescriptor.OwnerUserId=NULL
  FROM IWA_SecurityDescriptor, deleted
  WHERE IWA_SecurityDescriptor.OwnerUserId = deleted.UserId

  DELETE IWA_AccessControl FROM IWA_AccessControl, deleted
  WHERE IWA_AccessControl.UserId = deleted.UserId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_TaskDeleteTrigger
  ON IWA_Task FOR DELETE AS

  UPDATE IWA_Case  SET IWA_Case.CreatorTaskId=NULL
  FROM IWA_Case, deleted
  WHERE IWA_Case.CreatorTaskId = deleted.TaskId

  DELETE IWA_TaskData FROM IWA_TaskData, deleted
  WHERE IWA_TaskData.TaskId = deleted.TaskId

  DELETE IWA_WorkflowEvent FROM IWA_WorkflowEvent, deleted
  WHERE IWA_WorkflowEvent.TaskId = deleted.TaskId

  DELETE IWA_IntermediateEvent FROM IWA_IntermediateEvent, deleted
  WHERE IWA_IntermediateEvent.TaskId = deleted.TaskId

  DELETE IWA_TaskNote FROM IWA_TaskNote, deleted
  WHERE IWA_TaskNote.TaskId = deleted.TaskId

  DELETE IWA_TaskAdditionalProperty FROM IWA_TaskAdditionalProperty, deleted
  WHERE IWA_TaskAdditionalProperty.TaskId = deleted.TaskId

  DELETE IWA_TaskLocation FROM IWA_TaskLocation, deleted
  WHERE IWA_TaskLocation.TaskId = deleted.TaskId

  DELETE IWA_PageArchive FROM IWA_PageArchive, deleted
  WHERE IWA_PageArchive.TaskId = deleted.TaskId


GO


-- Recreate views which depend on changed tables
CREATE VIEW IWA_TaskQuery
(
  TaskId,
  CaseId,
  ProcessModelId,
  ApplicationId,
  StartTaskSwitchEventId,
  EndTaskSwitchEventId,
  TaskStartId,
  TaskEndId,
  WorkerUserId,
  WorkerUserName,
  WorkerSessionId,
  ActivatorRoleId,
  ActivatorUserId,
  ActivatorName,
  ExpiryActivatorRoleId,
  ExpiryActivatorUserId,
  ExpiryActivatorName,
  ExpiryPriority,
  ExpiryTimestamp,
  ExpiryTaskStartElementPid,
  IsExpired,
  ExpiredCreatorTaskId,
  TimeoutedCreatorIntrmdtEventId,
  DelayTimestamp,
  "State",
  RequestPath,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  Priority,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendarId,
  WorkingTime,
  BusinessRuntime,
  FailedTimeoutTimestamp,
  NumberOfFailures,
  NumberOfResumes,
  KindCode,
  KindName,
  BusinessMilestoneTimestamp,
  CustomVarCharField1,
  CustomVarCharField2,
  CustomVarCharField3,
  CustomVarCharField4,
  CustomVarCharField5,
  CustomDecimalField1,
  CustomDecimalField2,
  CustomDecimalField3,
  CustomDecimalField4,
  CustomDecimalField5,
  CustomTimestampField1,
  CustomTimestampField2,
  CustomTimestampField3,
  CustomTimestampField4,
  CustomTimestampField5,
  IsUpdatedOnStart,
  IsOffline,
  CurrentPriority,
  CurrentActivatorName,
  CurrentActivatorRoleId,
  CurrentActivatorUserId,
  ProcessCategoryCode,
  ProcessCategoryName,
  ProcessCode,
  ProcessName,
  TypeCode,
  TypeName,
  SubTypeCode,
  SubTypeName,
  BusinessObjectCode,
  BusinessObjectName,
  BusinessMainContactId,
  BusinessMainContactName,
  BusinessStartTimestamp,
  BusinessCreatorUser
)
AS
  SELECT
    IWA_Task.TaskId,
    IWA_Task.CaseId,
    IWA_Task.ProcessModelId,
    IWA_Task.ApplicationId,
    IWA_Task.StartTaskSwitchEventId,
    IWA_Task.EndTaskSwitchEventId,
    IWA_Task.TaskStartId,
    IWA_Task.TaskEndId,
    IWA_Task.WorkerUserId,
    IWA_Task.WorkerUserName,
    IWA_Task.WorkerSessionId,
    IWA_Task.ActivatorRoleId,
    IWA_Task.ActivatorUserId,
    IWA_Task.ActivatorName,
    IWA_Task.ExpiryActivatorRoleId,
    IWA_Task.ExpiryActivatorUserId,
    IWA_Task.ExpiryActivatorName,
    IWA_Task.ExpiryPriority,
    IWA_Task.ExpiryTimestamp,
    IWA_Task.ExpiryTaskStartElementPid,
    IWA_Task.IsExpired,
    IWA_Task.ExpiredCreatorTaskId,
    IWA_Task.TimeoutedCreatorIntrmdtEventId,
    IWA_Task.DelayTimestamp,
    IWA_Task."State",
    IWA_Task.RequestPath,
    IWA_Task.DisplayNameTemplate,
    IWA_Task.Name,
    IWA_Task.DisplayDescriptionTemplate,
    IWA_Task.Description,
    IWA_Task.Priority,
    IWA_Task.StartTimestamp,
    IWA_Task.EndTimestamp,
    IWA_Task.BusinessCalendarId,
    IWA_Task.WorkingTime,
    IWA_Task.BusinessRuntime,
    IWA_Task.FailedTimeoutTimestamp,
    IWA_Task.NumberOfFailures,
    IWA_Task.NumberOfResumes,
    IWA_Task.KindCode,
    IWA_Task.KindName,
    IWA_Task.BusinessMilestoneTimestamp,
    IWA_Task.CustomVarCharField1,
    IWA_Task.CustomVarCharField2,
    IWA_Task.CustomVarCharField3,
    IWA_Task.CustomVarCharField4,
    IWA_Task.CustomVarCharField5,
    IWA_Task.CustomDecimalField1,
    IWA_Task.CustomDecimalField2,
    IWA_Task.CustomDecimalField3,
    IWA_Task.CustomDecimalField4,
    IWA_Task.CustomDecimalField5,
    IWA_Task.CustomTimestampField1,
    IWA_Task.CustomTimestampField2,
    IWA_Task.CustomTimestampField3,
    IWA_Task.CustomTimestampField4,
    IWA_Task.CustomTimestampField5,
    IWA_Task.IsUpdatedOnStart,
    IWA_Task.IsOffline,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryPriority WHEN 0 THEN IWA_Task.Priority END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorName WHEN 0 THEN IWA_Task.ActivatorName END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorRoleId WHEN 0 THEN IWA_Task.ActivatorRoleId END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorUserId WHEN 0 THEN IWA_Task.ActivatorUserId END,
    IWA_Case.ProcessCategoryCode,
    IWA_Case.ProcessCategoryName,
    IWA_Case.ProcessCode,
    IWA_Case.ProcessName,
    IWA_Case.TypeCode,
    IWA_Case.TypeName,
    IWA_Case.SubTypeCode,
    IWA_Case.SubTypeName,
    IWA_Case.BusinessObjectCode,
    IWA_Case.BusinessObjectName,
    IWA_Case.BusinessMainContactId,
    IWA_Case.BusinessMainContactName,
    IWA_Case.BusinessStartTimestamp,
    IWA_Case.BusinessCreatorUser
  FROM IWA_Task, IWA_Case
  WHERE IWA_Task.CaseId = IWA_Case.CaseId
GO

-- Add new added default table content
INSERT INTO IWA_Permission (PermissionId, Name) VALUES (586, 'DocumentRead')
GO

INSERT INTO IWA_Permission (PermissionId, Name) VALUES (587, 'DocumentWrite')
GO

INSERT INTO IWA_Permission (PermissionId, Name) VALUES (588, 'DocumentOfInvolvedCaseRead')
GO

INSERT INTO IWA_Permission (PermissionId, Name) VALUES (589, 'DocumentOfInvolvedCaseWrite')
GO

INSERT INTO IWA_PermissionGroup (PermissionGroupId, ParentPermissionGroupId, Name) VALUES (89, 6, 'DocumentPermissions')
GO

INSERT INTO IWA_PermissionGroup (PermissionGroupId, ParentPermissionGroupId, Name) VALUES (90, 13, 'SystemwideDocumentPermissions')
GO

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (89, 586)
GO

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (89, 587)
GO

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (89, 588)
GO

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (89, 589)
GO

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (90, 586)
GO

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (90, 587)
GO

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (90, 588)
GO

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (90, 589)
GO

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0
GO


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=35
GO
