-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 36 to version 37
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_RoleDeleteTrigger
GO

-- Create new added tables
CREATE TABLE IWA_RoleRoleMember
(
  RoleId BIGINT NOT NULL,
  RoleMemberId BIGINT NOT NULL,
  PRIMARY KEY (RoleId, RoleMemberId)
)
GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_RoleDeleteTrigger
  ON IWA_Role FOR DELETE AS
  IF (@@ROWCOUNT > 0)
  BEGIN

    UPDATE IWA_Task    SET IWA_Task.State=9, IWA_Task.FailedTimeoutTimestamp=NULL, IWA_Task.WorkerUserId=NULL, IWA_Task.WorkerUserName=NULL
    FROM IWA_Task, deleted
    WHERE ((IWA_Task.ActivatorRoleId = deleted.RoleId AND IWA_Task.IsExpired = 0) OR (IWA_Task.ExpiryActivatorRoleId = deleted.RoleId AND IWA_Task.IsExpired = 1)) AND (IWA_Task."State" = 3 OR IWA_Task."State" = 4 OR IWA_Task."State" = 8 OR IWA_Task."State" = 10)

    DELETE IWA_ProcessModelVersionRole FROM IWA_ProcessModelVersionRole, deleted
    WHERE IWA_ProcessModelVersionRole.RoleId = deleted.RoleId

    DELETE IWA_Role FROM IWA_Role, deleted
    WHERE IWA_Role.ParentRoleId = deleted.RoleId

    DELETE IWA_RoleProperty FROM IWA_RoleProperty, deleted
    WHERE IWA_RoleProperty.RoleId = deleted.RoleId

    DELETE IWA_RoleRoleMember FROM IWA_RoleRoleMember, deleted
    WHERE IWA_RoleRoleMember.RoleId = deleted.RoleId

    DELETE IWA_RoleRoleMember FROM IWA_RoleRoleMember, deleted
    WHERE IWA_RoleRoleMember.RoleMemberId = deleted.RoleId

    DELETE IWA_UserRole FROM IWA_UserRole, deleted
    WHERE IWA_UserRole.RoleId = deleted.RoleId

    DELETE IWA_UserSubstitute FROM IWA_UserSubstitute, deleted
    WHERE IWA_UserSubstitute.SubstituteForRoleId = deleted.RoleId

    UPDATE IWA_StartElement    SET IWA_StartElement.ActivatorRoleId=NULL
    FROM IWA_StartElement, deleted
    WHERE IWA_StartElement.ActivatorRoleId = deleted.RoleId

    UPDATE IWA_StartEventElement    SET IWA_StartEventElement.ActivatorRoleId=NULL
    FROM IWA_StartEventElement, deleted
    WHERE IWA_StartEventElement.ActivatorRoleId = deleted.RoleId

    UPDATE IWA_WebServiceProcStartElement    SET IWA_WebServiceProcStartElement.ActivatorRoleId=NULL
    FROM IWA_WebServiceProcStartElement, deleted
    WHERE IWA_WebServiceProcStartElement.ActivatorRoleId = deleted.RoleId

    UPDATE IWA_Task    SET IWA_Task.ActivatorRoleId=NULL
    FROM IWA_Task, deleted
    WHERE IWA_Task.ActivatorRoleId = deleted.RoleId

    UPDATE IWA_Task    SET IWA_Task.ExpiryActivatorRoleId=NULL
    FROM IWA_Task, deleted
    WHERE IWA_Task.ExpiryActivatorRoleId = deleted.RoleId

    DELETE IWA_AccessControl FROM IWA_AccessControl, deleted
    WHERE IWA_AccessControl.RoleId = deleted.RoleId

    END
GO

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0
GO


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=37
GO
