-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 44 to version 45
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_CaseDeleteTrigger
GO

-- Create new added tables
CREATE TABLE IWA_CaseMap
(
  CaseMapId BIGINT NOT NULL,
  ProcessModelVersionId BIGINT NOT NULL REFERENCES IWA_ProcessModelVersion(ProcessModelVersionId) ON DELETE CASCADE,
  ApplicationId BIGINT NOT NULL REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE,
  UUID VARCHAR(36) NOT NULL,
  Name VARCHAR(200) NOT NULL,
  Model VARCHAR(MAX) NOT NULL,
  PRIMARY KEY (CaseMapId),
  UNIQUE (ProcessModelVersionId, UUID)
)
GO

CREATE TABLE IWA_CaseMapBusinessCase
(
  BusinessCaseId BIGINT NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  CaseMapId BIGINT NOT NULL REFERENCES IWA_CaseMap(CaseMapId) ON DELETE CASCADE,
  PRIMARY KEY (BusinessCaseId)
)
GO

CREATE INDEX IWA_CaseMapBusCase_CsMpIdIdx
ON IWA_CaseMapBusinessCase (CaseMapId)
GO

CREATE TABLE IWA_CaseMapEvent
(
  CaseMapEventId BIGINT NOT NULL,
  BusinessCaseId BIGINT NOT NULL,
  "Timestamp" DATETIME NOT NULL,
  Kind INTEGER NOT NULL,
  Stage VARCHAR(200) NOT NULL,
  Process VARCHAR(200) NOT NULL,
  ProcessCaseId BIGINT NULL,
  Milestone VARCHAR(200) NOT NULL,
  Reason VARCHAR(200) NOT NULL,
  ProcessingState INTEGER NOT NULL,
  ProcessingErrorMessage VARCHAR(750) NOT NULL,
  ProcessingErrorCount INTEGER NOT NULL,
  ProcessingRetryTimestamp DATETIME NULL,
  PRIMARY KEY (CaseMapEventId)
)
GO

CREATE INDEX IWA_CaseMapEvent_BcId
ON IWA_CaseMapEvent (BusinessCaseId)
GO

CREATE INDEX IWA_CaseMapEvent_PrcRtryTstmp
ON IWA_CaseMapEvent (ProcessingRetryTimestamp)
GO

CREATE INDEX IWA_CaseMapEvent_PrcState
ON IWA_CaseMapEvent (ProcessingState)
GO

CREATE TABLE IWA_BusinessCaseData
(
  BusinessDataId VARCHAR(100) NOT NULL,
  ObjectType VARCHAR(255) NOT NULL,
  BusinessCaseId BIGINT NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  PRIMARY KEY (BusinessDataId),
  UNIQUE (BusinessCaseId, ObjectType)
)
GO


-- Create trigger which depend on new added table IWA_CaseMapBusinessCase
CREATE TRIGGER IWA_CaseMapBusinessCaseDeleteTrigger
  ON IWA_CaseMapBusinessCase FOR DELETE AS

  DELETE IWA_CaseMapEvent FROM IWA_CaseMapEvent, deleted
  WHERE IWA_CaseMapEvent.BusinessCaseId = deleted.BusinessCaseId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_CaseDeleteTrigger
  ON IWA_Case FOR DELETE AS
  IF (@@ROWCOUNT > 0)
  BEGIN

    DELETE IWA_TaskSwitchEvent FROM IWA_TaskSwitchEvent, deleted
    WHERE IWA_TaskSwitchEvent.CaseId = deleted.CaseId

    UPDATE IWA_Case    SET IWA_Case.BusinessCaseId=NULL
    FROM IWA_Case, deleted
    WHERE IWA_Case.BusinessCaseId = deleted.CaseId

    DELETE IWA_Task FROM IWA_Task, deleted
    WHERE IWA_Task.CaseId = deleted.CaseId

    DELETE IWA_WorkflowEvent FROM IWA_WorkflowEvent, deleted
    WHERE IWA_WorkflowEvent.CaseId = deleted.CaseId

    DELETE IWA_CaseMapEvent FROM IWA_CaseMapEvent, deleted
    WHERE IWA_CaseMapEvent.ProcessCaseId = deleted.CaseId

    DELETE IWA_CaseNote FROM IWA_CaseNote, deleted
    WHERE IWA_CaseNote.CaseId = deleted.CaseId

    DELETE IWA_CaseAdditionalProperty FROM IWA_CaseAdditionalProperty, deleted
    WHERE IWA_CaseAdditionalProperty.CaseId = deleted.CaseId

    END
GO

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0
GO


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=45
GO
