-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 48 to version 49
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------

-- Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_TaskQuery
GO

DROP VIEW IWA_CaseQuery
GO


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ProcessModelVersionDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_RoleDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_UserDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ContentManagementSystemDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ContentObjectDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ContentObjectValueDeleteTrigger
GO

-- Drop no longer exisiting table
DROP TABLE IWA_ProcessModelVersionRole
GO

-- Drop no longer exisiting table
DROP TABLE IWA_StartPage
GO

-- Drop no longer exisiting table
DROP TABLE IWA_ContentDataInteger
GO

-- Drop no longer exisiting table
DROP TABLE IWA_ContentDataFloat
GO

-- Drop no longer exisiting table
DROP TABLE IWA_ContentDataDateTime
GO

-- Drop no longer exisiting table
DROP TABLE IWA_ContentDataDecimal
GO

-- Added columns of table IWA_Case
ALTER TABLE IWA_Case ADD
  OwnerRoleId BIGINT NULL
GO
ALTER TABLE IWA_Case ADD
  OwnerUserId BIGINT NULL
GO
ALTER TABLE IWA_Case ADD
  OwnerName VARCHAR(200) NULL
GO

-- Create new indexes of table IWA_Case
CREATE INDEX IWA_Case_OwnerRoleIdIndex
ON IWA_Case (OwnerRoleId)
GO

CREATE INDEX IWA_Case_OwnerUserIdIndex
ON IWA_Case (OwnerUserId)
GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ProcessModelVersionDeleteTrigger
  ON IWA_ProcessModelVersion FOR DELETE AS

  DELETE IWA_PageElement FROM IWA_PageElement, deleted
  WHERE IWA_PageElement.ProcessModelVersionId = deleted.ProcessModelVersionId

  DELETE IWA_TaskElement FROM IWA_TaskElement, deleted
  WHERE IWA_TaskElement.ProcessModelVersionId = deleted.ProcessModelVersionId

  DELETE IWA_WebServiceProcess FROM IWA_WebServiceProcess, deleted
  WHERE IWA_WebServiceProcess.ProcessModelVersionId = deleted.ProcessModelVersionId

  DELETE IWA_ContentManagementSystem FROM IWA_ContentManagementSystem, deleted
  WHERE IWA_ContentManagementSystem.ProcessModelVersionId = deleted.ProcessModelVersionId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_RoleDeleteTrigger
  ON IWA_Role FOR DELETE AS
  IF (@@ROWCOUNT > 0)
  BEGIN

    UPDATE IWA_Task    SET IWA_Task.State=9, IWA_Task.FailedTimeoutTimestamp=NULL, IWA_Task.WorkerUserId=NULL, IWA_Task.WorkerUserName=NULL
    FROM IWA_Task, deleted
    WHERE ((IWA_Task.ActivatorRoleId = deleted.RoleId AND IWA_Task.IsExpired = 0) OR (IWA_Task.ExpiryActivatorRoleId = deleted.RoleId AND IWA_Task.IsExpired = 1)) AND (IWA_Task."State" = 3 OR IWA_Task."State" = 4 OR IWA_Task."State" = 8 OR IWA_Task."State" = 10)

    DELETE IWA_Role FROM IWA_Role, deleted
    WHERE IWA_Role.ParentRoleId = deleted.RoleId

    DELETE IWA_RoleProperty FROM IWA_RoleProperty, deleted
    WHERE IWA_RoleProperty.RoleId = deleted.RoleId

    DELETE IWA_RoleRoleMember FROM IWA_RoleRoleMember, deleted
    WHERE IWA_RoleRoleMember.RoleId = deleted.RoleId

    DELETE IWA_RoleRoleMember FROM IWA_RoleRoleMember, deleted
    WHERE IWA_RoleRoleMember.RoleMemberId = deleted.RoleId

    DELETE IWA_UserRole FROM IWA_UserRole, deleted
    WHERE IWA_UserRole.RoleId = deleted.RoleId

    DELETE IWA_UserSubstitute FROM IWA_UserSubstitute, deleted
    WHERE IWA_UserSubstitute.SubstituteForRoleId = deleted.RoleId

    UPDATE IWA_StartElement    SET IWA_StartElement.ActivatorRoleId=NULL
    FROM IWA_StartElement, deleted
    WHERE IWA_StartElement.ActivatorRoleId = deleted.RoleId

    UPDATE IWA_StartEventElement    SET IWA_StartEventElement.ActivatorRoleId=NULL
    FROM IWA_StartEventElement, deleted
    WHERE IWA_StartEventElement.ActivatorRoleId = deleted.RoleId

    UPDATE IWA_WebServiceProcStartElement    SET IWA_WebServiceProcStartElement.ActivatorRoleId=NULL
    FROM IWA_WebServiceProcStartElement, deleted
    WHERE IWA_WebServiceProcStartElement.ActivatorRoleId = deleted.RoleId

    UPDATE IWA_Case    SET IWA_Case.OwnerRoleId=NULL
    FROM IWA_Case, deleted
    WHERE IWA_Case.OwnerRoleId = deleted.RoleId

    UPDATE IWA_Task    SET IWA_Task.ActivatorRoleId=NULL
    FROM IWA_Task, deleted
    WHERE IWA_Task.ActivatorRoleId = deleted.RoleId

    UPDATE IWA_Task    SET IWA_Task.ExpiryActivatorRoleId=NULL
    FROM IWA_Task, deleted
    WHERE IWA_Task.ExpiryActivatorRoleId = deleted.RoleId

    DELETE IWA_AccessControl FROM IWA_AccessControl, deleted
    WHERE IWA_AccessControl.RoleId = deleted.RoleId

    END
GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_UserDeleteTrigger
  ON IWA_User FOR DELETE AS

  UPDATE IWA_Task  SET IWA_Task.State=9, IWA_Task.FailedTimeoutTimestamp=NULL, IWA_Task.WorkerUserId=NULL, IWA_Task.WorkerUserName=NULL
  FROM IWA_Task, deleted
  WHERE ((IWA_Task.ActivatorUserId = deleted.UserId AND IWA_Task.IsExpired = 0) OR (IWA_Task.ExpiryActivatorUserId = deleted.UserId AND IWA_Task.IsExpired = 1)) AND (IWA_Task."State" = 3 OR IWA_Task."State" = 4 OR IWA_Task."State" = 8 OR IWA_Task."State" = 10)

  UPDATE IWA_Task  SET IWA_Task.State=4, IWA_Task.WorkerUserName=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.WorkerUserId = deleted.UserId AND IWA_Task."State" = 8

  DELETE IWA_UserRole FROM IWA_UserRole, deleted
  WHERE IWA_UserRole.UserId = deleted.UserId

  DELETE IWA_UserProperty FROM IWA_UserProperty, deleted
  WHERE IWA_UserProperty.UserId = deleted.UserId

  DELETE IWA_RichDialogUserContext FROM IWA_RichDialogUserContext, deleted
  WHERE IWA_RichDialogUserContext.UserId = deleted.UserId

  DELETE IWA_UserAbsence FROM IWA_UserAbsence, deleted
  WHERE IWA_UserAbsence.UserId = deleted.UserId

  DELETE IWA_UserSubstitute FROM IWA_UserSubstitute, deleted
  WHERE IWA_UserSubstitute.UserId = deleted.UserId

  DELETE IWA_UserSubstitute FROM IWA_UserSubstitute, deleted
  WHERE IWA_UserSubstitute.SubstituteUserId = deleted.UserId

  UPDATE IWA_StartElement  SET IWA_StartElement.ActivatorUserId=NULL
  FROM IWA_StartElement, deleted
  WHERE IWA_StartElement.ActivatorUserId = deleted.UserId

  UPDATE IWA_Case  SET IWA_Case.CreatorUserId=NULL
  FROM IWA_Case, deleted
  WHERE IWA_Case.CreatorUserId = deleted.UserId

  UPDATE IWA_Case  SET IWA_Case.OwnerUserId=NULL
  FROM IWA_Case, deleted
  WHERE IWA_Case.OwnerUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.WorkerUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.WorkerUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.ActivatorUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.ActivatorUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.ExpiryActivatorUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.ExpiryActivatorUserId = deleted.UserId

  UPDATE IWA_WorkflowEvent  SET IWA_WorkflowEvent.UserId=NULL
  FROM IWA_WorkflowEvent, deleted
  WHERE IWA_WorkflowEvent.UserId = deleted.UserId

  UPDATE IWA_Note  SET IWA_Note.UserId=NULL
  FROM IWA_Note, deleted
  WHERE IWA_Note.UserId = deleted.UserId

  DELETE IWA_UserLocation FROM IWA_UserLocation, deleted
  WHERE IWA_UserLocation.UserId = deleted.UserId

  UPDATE IWA_SignalEvent  SET IWA_SignalEvent.SentByUserId=NULL
  FROM IWA_SignalEvent, deleted
  WHERE IWA_SignalEvent.SentByUserId = deleted.UserId

  UPDATE IWA_PageArchive  SET IWA_PageArchive.UserId=NULL
  FROM IWA_PageArchive, deleted
  WHERE IWA_PageArchive.UserId = deleted.UserId

  UPDATE IWA_SecurityDescriptor  SET IWA_SecurityDescriptor.OwnerUserId=NULL
  FROM IWA_SecurityDescriptor, deleted
  WHERE IWA_SecurityDescriptor.OwnerUserId = deleted.UserId

  DELETE IWA_AccessControl FROM IWA_AccessControl, deleted
  WHERE IWA_AccessControl.UserId = deleted.UserId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ContentManagementSystemDeleteTrigger
  ON IWA_ContentManagementSystem FOR DELETE AS

  DELETE IWA_SupportedLanguage FROM IWA_SupportedLanguage, deleted
  WHERE IWA_SupportedLanguage.ContentManagementSystemId = deleted.ContentManagementSystemId

  DELETE IWA_ContentObject FROM IWA_ContentObject, deleted
  WHERE IWA_ContentObject.ContentManagementSystemId = deleted.ContentManagementSystemId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ContentObjectDeleteTrigger
  ON IWA_ContentObject FOR DELETE AS
  IF (@@ROWCOUNT > 0)
  BEGIN

    UPDATE IWA_ContentManagementSystem    SET IWA_ContentManagementSystem.DefaultPageLayoutId=NULL
    FROM IWA_ContentManagementSystem, deleted
    WHERE IWA_ContentManagementSystem.DefaultPageLayoutId = deleted.ContentObjectId

    UPDATE IWA_ContentManagementSystem    SET IWA_ContentManagementSystem.DefaultPageStyleSheetId=NULL
    FROM IWA_ContentManagementSystem, deleted
    WHERE IWA_ContentManagementSystem.DefaultPageStyleSheetId = deleted.ContentObjectId

    DELETE IWA_ContentObject FROM IWA_ContentObject, deleted
    WHERE IWA_ContentObject.ParentContentObjectId = deleted.ContentObjectId

    DELETE IWA_ContentObjectValue FROM IWA_ContentObjectValue, deleted
    WHERE IWA_ContentObjectValue.ContentObjectId = deleted.ContentObjectId

    END
GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ContentObjectValueDeleteTrigger
  ON IWA_ContentObjectValue FOR DELETE AS

  DELETE IWA_ContentDataString FROM IWA_ContentDataString, deleted
  WHERE IWA_ContentDataString.ContentObjectValueId = deleted.ContentObjectValueId

  DELETE IWA_ContentDataText FROM IWA_ContentDataText, deleted
  WHERE IWA_ContentDataText.ContentObjectValueId = deleted.ContentObjectValueId

  DELETE IWA_ContentDataImage FROM IWA_ContentDataImage, deleted
  WHERE IWA_ContentDataImage.ContentObjectValueId = deleted.ContentObjectValueId


GO


-- Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_TaskQuery
(
  TaskId,
  CaseId,
  ProcessModelId,
  ApplicationId,
  StartTaskSwitchEventId,
  EndTaskSwitchEventId,
  TaskStartId,
  TaskEndId,
  WorkerUserId,
  WorkerUserName,
  WorkerUserDisplayName,
  WorkerSessionId,
  ActivatorRoleId,
  ActivatorUserId,
  ActivatorName,
  ActivatorDisplayName,
  ExpiryActivatorRoleId,
  ExpiryActivatorUserId,
  ExpiryActivatorName,
  ExpiryActivatorDisplayName,
  ExpiryPriority,
  ExpiryTimestamp,
  ExpiryTaskStartElementPid,
  IsExpired,
  ExpiredCreatorTaskId,
  TimeoutedCreatorIntrmdtEventId,
  DelayTimestamp,
  "State",
  RequestPath,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  Priority,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendarId,
  WorkingTime,
  BusinessRuntime,
  FailedTimeoutTimestamp,
  NumberOfFailures,
  NumberOfResumes,
  Category,
  KindCode,
  KindName,
  BusinessMilestoneTimestamp,
  CustomVarCharField1,
  CustomVarCharField2,
  CustomVarCharField3,
  CustomVarCharField4,
  CustomVarCharField5,
  CustomDecimalField1,
  CustomDecimalField2,
  CustomDecimalField3,
  CustomDecimalField4,
  CustomDecimalField5,
  CustomTimestampField1,
  CustomTimestampField2,
  CustomTimestampField3,
  CustomTimestampField4,
  CustomTimestampField5,
  IsUpdatedOnStart,
  IsOffline,
  CurrentPriority,
  CurrentActivatorName,
  CurrentActivatorDisplayName,
  CurrentActivatorRoleId,
  CurrentActivatorUserId,
  BusinessCaseId,
  ProcessCategoryCode,
  ProcessCategoryName,
  ProcessCode,
  ProcessName,
  TypeCode,
  TypeName,
  SubTypeCode,
  SubTypeName,
  BusinessObjectCode,
  BusinessObjectName,
  BusinessMainContactId,
  BusinessMainContactName,
  BusinessStartTimestamp,
  BusinessCreatorUser
)
AS
  SELECT
    IWA_Task.TaskId,
    IWA_Task.CaseId,
    IWA_Task.ProcessModelId,
    IWA_Task.ApplicationId,
    IWA_Task.StartTaskSwitchEventId,
    IWA_Task.EndTaskSwitchEventId,
    IWA_Task.TaskStartId,
    IWA_Task.TaskEndId,
    IWA_Task.WorkerUserId,
    IWA_Task.WorkerUserName,
    CASE WHEN WorkerUserId IS NOT NULL AND LEN(WorkerUser.FullName) > 0 THEN WorkerUser.FullName WHEN WorkerUserId IS NOT NULL THEN WorkerUser.Name ELSE NULL END,
    IWA_Task.WorkerSessionId,
    IWA_Task.ActivatorRoleId,
    IWA_Task.ActivatorUserId,
    IWA_Task.ActivatorName,
    CASE WHEN IWA_Task.ActivatorUserId IS NOT NULL AND LEN(ActivatorUser.FullName) > 0 THEN ActivatorUser.FullName WHEN IWA_Task.ActivatorUserId IS NOT NULL THEN ActivatorUser.Name WHEN IWA_Task.ActivatorRoleId IS NOT NULL AND LEN(ActivatorRole.DisplayNameTemplate) > 0 THEN ActivatorRole.DisplayNameTemplate WHEN IWA_Task.ActivatorRoleId IS NOT NULL THEN ActivatorRole.Name ELSE NULL END,
    IWA_Task.ExpiryActivatorRoleId,
    IWA_Task.ExpiryActivatorUserId,
    IWA_Task.ExpiryActivatorName,
    CASE WHEN IWA_Task.ExpiryActivatorUserId IS NOT NULL AND LEN(ExpiryActivatorUser.FullName) > 0 THEN ExpiryActivatorUser.FullName WHEN IWA_Task.ExpiryActivatorUserId IS NOT NULL THEN ExpiryActivatorUser.Name WHEN IWA_Task.ExpiryActivatorRoleId IS NOT NULL AND LEN(ExpiryActivatorRole.DisplayNameTemplate) > 0 THEN ExpiryActivatorRole.DisplayNameTemplate WHEN IWA_Task.ExpiryActivatorRoleId IS NOT NULL THEN ExpiryActivatorRole.Name ELSE NULL END,
    IWA_Task.ExpiryPriority,
    IWA_Task.ExpiryTimestamp,
    IWA_Task.ExpiryTaskStartElementPid,
    IWA_Task.IsExpired,
    IWA_Task.ExpiredCreatorTaskId,
    IWA_Task.TimeoutedCreatorIntrmdtEventId,
    IWA_Task.DelayTimestamp,
    IWA_Task."State",
    IWA_Task.RequestPath,
    IWA_Task.DisplayNameTemplate,
    IWA_Task.Name,
    IWA_Task.DisplayDescriptionTemplate,
    IWA_Task.Description,
    IWA_Task.Priority,
    IWA_Task.StartTimestamp,
    IWA_Task.EndTimestamp,
    IWA_Task.BusinessCalendarId,
    IWA_Task.WorkingTime,
    IWA_Task.BusinessRuntime,
    IWA_Task.FailedTimeoutTimestamp,
    IWA_Task.NumberOfFailures,
    IWA_Task.NumberOfResumes,
    IWA_Task.Category,
    IWA_Task.KindCode,
    IWA_Task.KindName,
    IWA_Task.BusinessMilestoneTimestamp,
    IWA_Task.CustomVarCharField1,
    IWA_Task.CustomVarCharField2,
    IWA_Task.CustomVarCharField3,
    IWA_Task.CustomVarCharField4,
    IWA_Task.CustomVarCharField5,
    IWA_Task.CustomDecimalField1,
    IWA_Task.CustomDecimalField2,
    IWA_Task.CustomDecimalField3,
    IWA_Task.CustomDecimalField4,
    IWA_Task.CustomDecimalField5,
    IWA_Task.CustomTimestampField1,
    IWA_Task.CustomTimestampField2,
    IWA_Task.CustomTimestampField3,
    IWA_Task.CustomTimestampField4,
    IWA_Task.CustomTimestampField5,
    IWA_Task.IsUpdatedOnStart,
    IWA_Task.IsOffline,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryPriority WHEN 0 THEN IWA_Task.Priority END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorName WHEN 0 THEN IWA_Task.ActivatorName END,
    CASE WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorUserId IS NOT NULL AND LEN(ExpiryActivatorUser.FullName) > 0 THEN ExpiryActivatorUser.FullName WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorUserId IS NOT NULL THEN ExpiryActivatorUser.Name WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorRoleId IS NOT NULL AND LEN(ExpiryActivatorRole.DisplayNameTemplate) > 0 THEN ExpiryActivatorRole.DisplayNameTemplate WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorRoleId IS NOT NULL THEN ExpiryActivatorRole.Name WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorUserId IS NOT NULL AND LEN(ActivatorUser.FullName) > 0 THEN ActivatorUser.FullName WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorUserId IS NOT NULL THEN ActivatorUser.Name WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorRoleId IS NOT NULL AND LEN(ActivatorRole.DisplayNameTemplate) > 0 THEN ActivatorRole.DisplayNameTemplate WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorRoleId IS NOT NULL THEN ActivatorRole.Name ELSE NULL END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorRoleId WHEN 0 THEN IWA_Task.ActivatorRoleId END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorUserId WHEN 0 THEN IWA_Task.ActivatorUserId END,
    IWA_Case.BusinessCaseId,
    IWA_Case.ProcessCategoryCode,
    IWA_Case.ProcessCategoryName,
    IWA_Case.ProcessCode,
    IWA_Case.ProcessName,
    IWA_Case.TypeCode,
    IWA_Case.TypeName,
    IWA_Case.SubTypeCode,
    IWA_Case.SubTypeName,
    IWA_Case.BusinessObjectCode,
    IWA_Case.BusinessObjectName,
    IWA_Case.BusinessMainContactId,
    IWA_Case.BusinessMainContactName,
    IWA_Case.BusinessStartTimestamp,
    IWA_Case.BusinessCreatorUser
  FROM IWA_Task
    INNER JOIN IWA_Case ON IWA_Task.CaseId = IWA_Case.CaseId
    LEFT OUTER JOIN IWA_User AS ActivatorUser ON IWA_Task.ActivatorUserId = ActivatorUser.UserId
    LEFT OUTER JOIN IWA_Role AS ActivatorRole ON IWA_Task.ActivatorRoleId = ActivatorRole.RoleId
    LEFT OUTER JOIN IWA_User AS ExpiryActivatorUser ON IWA_Task.ExpiryActivatorUserId = ExpiryActivatorUser.UserId
    LEFT OUTER JOIN IWA_Role AS ExpiryActivatorRole ON IWA_Task.ExpiryActivatorRoleId = ExpiryActivatorRole.RoleId
    LEFT OUTER JOIN IWA_User AS WorkerUser ON IWA_Task.WorkerUserId = WorkerUser.UserId
GO

CREATE VIEW IWA_CaseQuery
(
  CaseId,
  BusinessCaseId,
  Kind,
  ApplicationId,
  ProcessModelId,
  TaskStartId,
  CreatorUserId,
  CreatorUserName,
  CreatorUserDisplayName,
  CreatorTaskId,
  EnvironmentId,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendarId,
  WorkingTime,
  BusinessRuntime,
  "State",
  Priority,
  Stage,
  OwnerRoleId,
  OwnerUserId,
  OwnerName,
  Category,
  ProcessCategoryCode,
  ProcessCategoryName,
  ProcessCode,
  ProcessName,
  TypeCode,
  TypeName,
  SubTypeCode,
  SubTypeName,
  BusinessStartTimestamp,
  BusinessMilestoneTimestamp,
  BusinessPriority,
  BusinessCreatorUser,
  BusinessMainContactType,
  BusinessMainContactId,
  BusinessMainContactName,
  BusinessMainContactDocDbCode,
  BusinessMainContactFolderId,
  BusinessCorrespondentId,
  BusinessObjectCode,
  BusinessObjectName,
  BusinessObjectDocDbCode,
  BusinessObjectFolderId,
  CustomVarCharField1,
  CustomVarCharField2,
  CustomVarCharField3,
  CustomVarCharField4,
  CustomVarCharField5,
  CustomDecimalField1,
  CustomDecimalField2,
  CustomDecimalField3,
  CustomDecimalField4,
  CustomDecimalField5,
  CustomTimestampField1,
  CustomTimestampField2,
  CustomTimestampField3,
  CustomTimestampField4,
  CustomTimestampField5
)
AS
  SELECT
    IWA_Case.CaseId,
    IWA_Case.BusinessCaseId,
    IWA_Case.Kind,
    IWA_Case.ApplicationId,
    IWA_Case.ProcessModelId,
    IWA_Case.TaskStartId,
    IWA_Case.CreatorUserId,
    IWA_Case.CreatorUserName,
    CASE WHEN IWA_Case.CreatorUserId IS NOT NULL AND LEN(IWA_User.FullName) > 0 THEN IWA_User.FullName WHEN IWA_Case.CreatorUserId IS NOT NULL THEN IWA_User.Name ELSE NULL END,
    IWA_Case.CreatorTaskId,
    IWA_Case.EnvironmentId,
    IWA_Case.DisplayNameTemplate,
    IWA_Case.Name,
    IWA_Case.DisplayDescriptionTemplate,
    IWA_Case.Description,
    IWA_Case.StartTimestamp,
    IWA_Case.EndTimestamp,
    IWA_Case.BusinessCalendarId,
    IWA_Case.WorkingTime,
    IWA_Case.BusinessRuntime,
    IWA_Case."State",
    IWA_Case.Priority,
    IWA_Case.Stage,
    IWA_Case.OwnerRoleId,
    IWA_Case.OwnerUserId,
    IWA_Case.OwnerName,
    IWA_Case.Category,
    IWA_Case.ProcessCategoryCode,
    IWA_Case.ProcessCategoryName,
    IWA_Case.ProcessCode,
    IWA_Case.ProcessName,
    IWA_Case.TypeCode,
    IWA_Case.TypeName,
    IWA_Case.SubTypeCode,
    IWA_Case.SubTypeName,
    IWA_Case.BusinessStartTimestamp,
    IWA_Case.BusinessMilestoneTimestamp,
    IWA_Case.BusinessPriority,
    IWA_Case.BusinessCreatorUser,
    IWA_Case.BusinessMainContactType,
    IWA_Case.BusinessMainContactId,
    IWA_Case.BusinessMainContactName,
    IWA_Case.BusinessMainContactDocDbCode,
    IWA_Case.BusinessMainContactFolderId,
    IWA_Case.BusinessCorrespondentId,
    IWA_Case.BusinessObjectCode,
    IWA_Case.BusinessObjectName,
    IWA_Case.BusinessObjectDocDbCode,
    IWA_Case.BusinessObjectFolderId,
    IWA_Case.CustomVarCharField1,
    IWA_Case.CustomVarCharField2,
    IWA_Case.CustomVarCharField3,
    IWA_Case.CustomVarCharField4,
    IWA_Case.CustomVarCharField5,
    IWA_Case.CustomDecimalField1,
    IWA_Case.CustomDecimalField2,
    IWA_Case.CustomDecimalField3,
    IWA_Case.CustomDecimalField4,
    IWA_Case.CustomDecimalField5,
    IWA_Case.CustomTimestampField1,
    IWA_Case.CustomTimestampField2,
    IWA_Case.CustomTimestampField3,
    IWA_Case.CustomTimestampField4,
    IWA_Case.CustomTimestampField5
  FROM IWA_Case
    LEFT OUTER JOIN IWA_User ON IWA_Case.CreatorUserId = IWA_User.UserId
GO

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0
GO


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=49
GO
