-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 52 to version 53
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_CaseDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_TaskDeleteTrigger
GO

-- Drop trigger of no longer exisiting table
DROP TRIGGER IWA_TaskAdditionalPropertyDeleteTrigger
GO

-- Drop trigger of no longer exisiting table
DROP TRIGGER IWA_CaseAdditionalPropertyDeleteTrigger
GO

-- Drop no longer exisiting table
DROP TABLE IWA_TaskAdditionalProperty
GO

-- Drop no longer exisiting table
DROP TABLE IWA_CaseAdditionalProperty
GO

-- Drop no longer exisiting table
DROP TABLE IWA_AdditionalProperty
GO

-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_CaseDeleteTrigger
  ON IWA_Case FOR DELETE AS
  IF (@@ROWCOUNT > 0)
  BEGIN

    DELETE IWA_TaskSwitchEvent FROM IWA_TaskSwitchEvent, deleted
    WHERE IWA_TaskSwitchEvent.CaseId = deleted.CaseId

    UPDATE IWA_Case    SET IWA_Case.BusinessCaseId=NULL
    FROM IWA_Case, deleted
    WHERE IWA_Case.BusinessCaseId = deleted.CaseId

    DELETE IWA_Task FROM IWA_Task, deleted
    WHERE IWA_Task.CaseId = deleted.CaseId

    DELETE IWA_WorkflowEvent FROM IWA_WorkflowEvent, deleted
    WHERE IWA_WorkflowEvent.CaseId = deleted.CaseId

    DELETE IWA_CaseMapEvent FROM IWA_CaseMapEvent, deleted
    WHERE IWA_CaseMapEvent.ProcessCaseId = deleted.CaseId

    DELETE IWA_CaseNote FROM IWA_CaseNote, deleted
    WHERE IWA_CaseNote.CaseId = deleted.CaseId

    END
GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_TaskDeleteTrigger
  ON IWA_Task FOR DELETE AS

  UPDATE IWA_Case  SET IWA_Case.CreatorTaskId=NULL
  FROM IWA_Case, deleted
  WHERE IWA_Case.CreatorTaskId = deleted.TaskId

  DELETE IWA_TaskData FROM IWA_TaskData, deleted
  WHERE IWA_TaskData.TaskId = deleted.TaskId

  DELETE IWA_WorkflowEvent FROM IWA_WorkflowEvent, deleted
  WHERE IWA_WorkflowEvent.TaskId = deleted.TaskId

  DELETE IWA_IntermediateEvent FROM IWA_IntermediateEvent, deleted
  WHERE IWA_IntermediateEvent.TaskId = deleted.TaskId

  DELETE IWA_TaskNote FROM IWA_TaskNote, deleted
  WHERE IWA_TaskNote.TaskId = deleted.TaskId

  DELETE IWA_TaskLocation FROM IWA_TaskLocation, deleted
  WHERE IWA_TaskLocation.TaskId = deleted.TaskId

  DELETE IWA_TaskSignalEventReceiver FROM IWA_TaskSignalEventReceiver, deleted
  WHERE IWA_TaskSignalEventReceiver.WaitingTaskId = deleted.TaskId

  DELETE IWA_SignaledTask FROM IWA_SignaledTask, deleted
  WHERE IWA_SignaledTask.SignaledTaskId = deleted.TaskId

  UPDATE IWA_SignalEvent  SET IWA_SignalEvent.SentByTaskId=NULL
  FROM IWA_SignalEvent, deleted
  WHERE IWA_SignalEvent.SentByTaskId = deleted.TaskId

  DELETE IWA_PageArchive FROM IWA_PageArchive, deleted
  WHERE IWA_PageArchive.TaskId = deleted.TaskId


GO

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0
GO


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=53
GO
