# ---------------------------------------------------------------------------------
# 
# Converts the Xpert.ivy system database from version 32 to version 33
# 
# ---------------------------------------------------------------------------------
# 
# This script was automatically generated. Do not edit it. Instead edit the source file
# 
# ---------------------------------------------------------------------------------
# Database: MySQL
# ---------------------------------------------------------------------------------
# Copyright:
# ivyTeam AG, Alpenstrasse 9, 6304 Zug
# ---------------------------------------------------------------------------------

# Drop views which depend on changed tables
DROP VIEW IWA_TaskQuery;

DROP VIEW IWA_ProcessStart;

# Store Procedure to drop a foreign key constraint
CREATE PROCEDURE IWA_Drop_ForeignKey_Constraint(fk_schema VARCHAR(64), fk_table VARCHAR(64), fk_column VARCHAR(64))
BEGIN
  WHILE EXISTS(
    SELECT * FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE
    WHERE REFERENCED_COLUMN_NAME IS NOT NULL
      AND CAST(TABLE_SCHEMA AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_schema AS CHAR CHARACTER SET ascii)
      AND CAST(TABLE_NAME AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_table AS CHAR CHARACTER SET ascii)
      AND CAST(COLUMN_NAME AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_column AS CHAR CHARACTER SET ascii)
  ) 
  DO
    BEGIN
      SET @sqlstmt = (
        SELECT CONCAT('ALTER TABLE ',TABLE_SCHEMA,'.',TABLE_NAME,' DROP FOREIGN KEY ',CONSTRAINT_NAME)
        FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE
        WHERE REFERENCED_COLUMN_NAME IS NOT NULL
          AND CAST(TABLE_SCHEMA AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_schema AS CHAR CHARACTER SET ascii)
          AND CAST(TABLE_NAME AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_table AS CHAR CHARACTER SET ascii)
          AND CAST(COLUMN_NAME AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_column AS CHAR CHARACTER SET ascii)
        LIMIT 1
      );
      PREPARE stmt1 FROM @sqlstmt;
      EXECUTE stmt1;
    END;
  END WHILE;
END;
;

CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_WebService', 'ApplicationId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_WebServiceEnvironment', 'ApplicationId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_BusinessCalendar', 'ApplicationId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_Library', 'ApplicationId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_WebServiceEnvironment', 'EnvironmentId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_Case', 'EnvironmentId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_GlobalVariable', 'ParentGlobalVariableId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_WebServiceEnvironment', 'WebServiceId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_WebServicePortType', 'WebServiceId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_WebServiceEndpoint', 'WebServiceEnvironmentId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_WebServiceEndpoint', 'WebServicePortTypeId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_Application', 'BusinessCalendarId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_Environment', 'BusinessCalendarId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_BusinessCalendar', 'ParentCalendarId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_Case', 'BusinessCalendarId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_Task', 'BusinessCalendarId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_ExternalDatabase', 'ParentExternalDatabaseId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_Library', 'ProcessModelVersionId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_LibrarySpecification', 'LibraryId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_LibrarySpecification', 'ResolvedLibraryId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_LibraryVersionSpec', 'LibrarySpecificationId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_Role', 'ParentRoleId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_WebServiceProcStartElement', 'WebServiceProcessId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_AsyncProcessCaseData', 'CaseId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_EventLogData', 'EventLogId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_EventLogTaskHistory', 'EventLogId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_EventLogStatus', 'EventLogId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_ContentObject', 'ParentContentObjectId');

# Changed columns of table IWA_AsyncProcessCaseData
ALTER TABLE IWA_AsyncProcessCaseData MODIFY
  CaseId BIGINT NOT NULL;


# Changed columns of table IWA_ClusterNode
ALTER TABLE IWA_ClusterNode MODIFY
  ClusterNodeId BIGINT NOT NULL;
ALTER TABLE IWA_ClusterNode MODIFY
  MasterClusterNodeId BIGINT;


# Changed columns of table IWA_ClusterNodeProperty
ALTER TABLE IWA_ClusterNodeProperty MODIFY
  ClusterNodePropertyId BIGINT NOT NULL;
ALTER TABLE IWA_ClusterNodeProperty MODIFY
  ClusterNodeId BIGINT NOT NULL;


# Changed columns of table IWA_Application
ALTER TABLE IWA_Application MODIFY
  ApplicationId BIGINT NOT NULL;
ALTER TABLE IWA_Application MODIFY
  SystemUserId BIGINT;
ALTER TABLE IWA_Application MODIFY
  SecurityDescriptorId BIGINT DEFAULT NULL;
ALTER TABLE IWA_Application MODIFY
  BusinessCalendarId BIGINT;


# Changed columns of table IWA_ApplicationProperty
ALTER TABLE IWA_ApplicationProperty MODIFY
  ApplicationPropertyId BIGINT NOT NULL;
ALTER TABLE IWA_ApplicationProperty MODIFY
  ApplicationId BIGINT NOT NULL;


# Changed columns of table IWA_Environment
ALTER TABLE IWA_Environment MODIFY
  EnvironmentId BIGINT NOT NULL;
ALTER TABLE IWA_Environment MODIFY
  ApplicationId BIGINT NOT NULL;
ALTER TABLE IWA_Environment MODIFY
  BusinessCalendarId BIGINT;


# Changed columns of table IWA_GlobalVariable
ALTER TABLE IWA_GlobalVariable MODIFY
  GlobalVariableId BIGINT NOT NULL;
ALTER TABLE IWA_GlobalVariable MODIFY
  ApplicationId BIGINT NOT NULL;
ALTER TABLE IWA_GlobalVariable MODIFY
  ParentGlobalVariableId BIGINT;
ALTER TABLE IWA_GlobalVariable MODIFY
  EnvironmentId BIGINT;


# Changed columns of table IWA_WebService
ALTER TABLE IWA_WebService MODIFY
  WebServiceId BIGINT NOT NULL;
ALTER TABLE IWA_WebService MODIFY
  ApplicationId BIGINT NOT NULL;


# Changed columns of table IWA_WebServiceEnvironment
ALTER TABLE IWA_WebServiceEnvironment MODIFY
  WebServiceEnvironmentId BIGINT NOT NULL;
ALTER TABLE IWA_WebServiceEnvironment MODIFY
  ApplicationId BIGINT NOT NULL;
ALTER TABLE IWA_WebServiceEnvironment MODIFY
  WebServiceId BIGINT NOT NULL;
ALTER TABLE IWA_WebServiceEnvironment MODIFY
  EnvironmentId BIGINT;


# Changed columns of table IWA_WebServicePortType
ALTER TABLE IWA_WebServicePortType MODIFY
  WebServicePortTypeId BIGINT NOT NULL;
ALTER TABLE IWA_WebServicePortType MODIFY
  WebServiceId BIGINT NOT NULL;


# Changed columns of table IWA_WebServiceEndpoint
ALTER TABLE IWA_WebServiceEndpoint MODIFY
  WebServiceEndpointId BIGINT NOT NULL;
ALTER TABLE IWA_WebServiceEndpoint MODIFY
  WebServiceEnvironmentId BIGINT NOT NULL;
ALTER TABLE IWA_WebServiceEndpoint MODIFY
  WebServicePortTypeId BIGINT NOT NULL;


# Changed columns of table IWA_BusinessCalendar
ALTER TABLE IWA_BusinessCalendar MODIFY
  BusinessCalendarId BIGINT NOT NULL;
ALTER TABLE IWA_BusinessCalendar MODIFY
  ApplicationId BIGINT NOT NULL;
ALTER TABLE IWA_BusinessCalendar MODIFY
  ParentCalendarId BIGINT;


# Changed columns of table IWA_ExternalNamingAndDirectory
ALTER TABLE IWA_ExternalNamingAndDirectory MODIFY
  ExternalNamingAndDirectoryId BIGINT NOT NULL;
ALTER TABLE IWA_ExternalNamingAndDirectory MODIFY
  ApplicationId BIGINT NOT NULL;


# Changed columns of table IWA_ExternalDatabase
ALTER TABLE IWA_ExternalDatabase MODIFY
  ExternalDatabaseId BIGINT NOT NULL;
ALTER TABLE IWA_ExternalDatabase MODIFY
  ParentExternalDatabaseId BIGINT;
ALTER TABLE IWA_ExternalDatabase MODIFY
  EnvironmentId BIGINT;
ALTER TABLE IWA_ExternalDatabase MODIFY
  ApplicationId BIGINT NOT NULL;


# Changed columns of table IWA_ExternalDatabaseProperty
ALTER TABLE IWA_ExternalDatabaseProperty MODIFY
  ExternalDatabaseId BIGINT NOT NULL;
ALTER TABLE IWA_ExternalDatabaseProperty MODIFY
  ExternalDatabasePropertyId BIGINT NOT NULL;


# Changed columns of table IWA_ProcessModel
ALTER TABLE IWA_ProcessModel MODIFY
  ProcessModelId BIGINT NOT NULL;
ALTER TABLE IWA_ProcessModel MODIFY
  ApplicationId BIGINT NOT NULL;


# Changed columns of table IWA_ProcessModelVersion
ALTER TABLE IWA_ProcessModelVersion MODIFY
  ProcessModelVersionId BIGINT NOT NULL;
ALTER TABLE IWA_ProcessModelVersion MODIFY
  ProcessModelId BIGINT NOT NULL;


# Changed columns of table IWA_Library
ALTER TABLE IWA_Library MODIFY
  LibraryId BIGINT NOT NULL;
ALTER TABLE IWA_Library MODIFY
  ProcessModelVersionId BIGINT NOT NULL;
ALTER TABLE IWA_Library MODIFY
  ApplicationId BIGINT NOT NULL;


# Changed columns of table IWA_LibrarySpecification
ALTER TABLE IWA_LibrarySpecification MODIFY
  LibrarySpecificationId BIGINT NOT NULL;
ALTER TABLE IWA_LibrarySpecification MODIFY
  LibraryId BIGINT NOT NULL;
ALTER TABLE IWA_LibrarySpecification MODIFY
  ResolvedLibraryId BIGINT;


# Changed columns of table IWA_LibraryVersionSpec
ALTER TABLE IWA_LibraryVersionSpec MODIFY
  LibraryVersionSpecId BIGINT NOT NULL;
ALTER TABLE IWA_LibraryVersionSpec MODIFY
  LibrarySpecificationId BIGINT NOT NULL;


# Changed columns of table IWA_PageElement
ALTER TABLE IWA_PageElement MODIFY
  PageElementId BIGINT NOT NULL;
ALTER TABLE IWA_PageElement MODIFY
  ProcessModelVersionId BIGINT NOT NULL;


# Changed columns of table IWA_ProcessModelVersionRole
ALTER TABLE IWA_ProcessModelVersionRole MODIFY
  ProcessModelVersionId BIGINT NOT NULL;
ALTER TABLE IWA_ProcessModelVersionRole MODIFY
  RoleId BIGINT NOT NULL;


# Changed columns of table IWA_Role
ALTER TABLE IWA_Role MODIFY
  RoleId BIGINT NOT NULL;
ALTER TABLE IWA_Role MODIFY
  ParentRoleId BIGINT;
ALTER TABLE IWA_Role MODIFY
  ApplicationId BIGINT NOT NULL;


# Changed columns of table IWA_RoleProperty
ALTER TABLE IWA_RoleProperty MODIFY
  RoleId BIGINT NOT NULL;
ALTER TABLE IWA_RoleProperty MODIFY
  RolePropertyId BIGINT NOT NULL;


# Changed columns of table IWA_User
ALTER TABLE IWA_User MODIFY
  UserId BIGINT NOT NULL;
ALTER TABLE IWA_User MODIFY
  EMailLanguageId BIGINT;
ALTER TABLE IWA_User MODIFY
  ApplicationId BIGINT NOT NULL;

# Added columns of table IWA_User
ALTER TABLE IWA_User ADD COLUMN
  `State` INTEGER NOT NULL DEFAULT 0;


# Changed columns of table IWA_UserRole
ALTER TABLE IWA_UserRole MODIFY
  RoleId BIGINT NOT NULL;
ALTER TABLE IWA_UserRole MODIFY
  UserId BIGINT NOT NULL;


# Changed columns of table IWA_UserProperty
ALTER TABLE IWA_UserProperty MODIFY
  UserId BIGINT NOT NULL;
ALTER TABLE IWA_UserProperty MODIFY
  UserPropertyId BIGINT NOT NULL;


# Changed columns of table IWA_RichDialogUserContext
ALTER TABLE IWA_RichDialogUserContext MODIFY
  UserId BIGINT NOT NULL;
ALTER TABLE IWA_RichDialogUserContext MODIFY
  RichDialogUserContextId BIGINT NOT NULL;


# Changed columns of table IWA_UserAbsence
ALTER TABLE IWA_UserAbsence MODIFY
  UserAbsenceId BIGINT NOT NULL;
ALTER TABLE IWA_UserAbsence MODIFY
  UserId BIGINT NOT NULL;


# Changed columns of table IWA_UserSubstitute
ALTER TABLE IWA_UserSubstitute MODIFY
  UserSubstituteId BIGINT NOT NULL;
ALTER TABLE IWA_UserSubstitute MODIFY
  UserId BIGINT NOT NULL;
ALTER TABLE IWA_UserSubstitute MODIFY
  SubstituteUserId BIGINT NOT NULL;
ALTER TABLE IWA_UserSubstitute MODIFY
  SubstituteForRoleId BIGINT;


# Changed columns of table IWA_TaskElement
ALTER TABLE IWA_TaskElement MODIFY
  TaskElementId BIGINT NOT NULL;
ALTER TABLE IWA_TaskElement MODIFY
  ProcessModelVersionId BIGINT NOT NULL;


# Changed columns of table IWA_TaskStart
ALTER TABLE IWA_TaskStart MODIFY
  TaskStartId BIGINT NOT NULL;
ALTER TABLE IWA_TaskStart MODIFY
  TaskElementId BIGINT NOT NULL;


# Changed columns of table IWA_TaskEnd
ALTER TABLE IWA_TaskEnd MODIFY
  TaskEndId BIGINT NOT NULL;
ALTER TABLE IWA_TaskEnd MODIFY
  TaskElementId BIGINT NOT NULL;


# Changed columns of table IWA_TaskSwitchEvent
ALTER TABLE IWA_TaskSwitchEvent MODIFY
  TaskSwitchEventId BIGINT NOT NULL;
ALTER TABLE IWA_TaskSwitchEvent MODIFY
  TaskElementId BIGINT NOT NULL;
ALTER TABLE IWA_TaskSwitchEvent MODIFY
  CaseId BIGINT NOT NULL;


# Changed columns of table IWA_StartElement
ALTER TABLE IWA_StartElement MODIFY
  ActivatorRoleId BIGINT;
ALTER TABLE IWA_StartElement MODIFY
  TaskStartId BIGINT NOT NULL;
ALTER TABLE IWA_StartElement MODIFY
  ActivatorUserId BIGINT;


# Changed columns of table IWA_StartEventElement
ALTER TABLE IWA_StartEventElement MODIFY
  TaskStartId BIGINT NOT NULL;
ALTER TABLE IWA_StartEventElement MODIFY
  ActivatorRoleId BIGINT;


# Changed columns of table IWA_WebServiceProcess
ALTER TABLE IWA_WebServiceProcess MODIFY
  WebServiceProcessId BIGINT NOT NULL;
ALTER TABLE IWA_WebServiceProcess MODIFY
  ProcessModelVersionId BIGINT NOT NULL;


# Changed columns of table IWA_WebServiceProcStartElement
ALTER TABLE IWA_WebServiceProcStartElement MODIFY
  ActivatorRoleId BIGINT;
ALTER TABLE IWA_WebServiceProcStartElement MODIFY
  TaskStartId BIGINT NOT NULL;
ALTER TABLE IWA_WebServiceProcStartElement MODIFY
  WebServiceProcessId BIGINT NOT NULL;


# Changed columns of table IWA_IntermediateEventElement
ALTER TABLE IWA_IntermediateEventElement MODIFY
  TaskStartId BIGINT NOT NULL;


# Changed columns of table IWA_Case
ALTER TABLE IWA_Case MODIFY
  CaseId BIGINT NOT NULL;
ALTER TABLE IWA_Case MODIFY
  ApplicationId BIGINT NOT NULL;
ALTER TABLE IWA_Case MODIFY
  ProcessModelId BIGINT NOT NULL;
ALTER TABLE IWA_Case MODIFY
  TaskStartId BIGINT NOT NULL;
ALTER TABLE IWA_Case MODIFY
  CreatorUserId BIGINT;
ALTER TABLE IWA_Case MODIFY
  CreatorTaskId BIGINT;
ALTER TABLE IWA_Case MODIFY
  EnvironmentId BIGINT;
ALTER TABLE IWA_Case MODIFY
  BusinessCalendarId BIGINT;
ALTER TABLE IWA_Case MODIFY
  WorkingTime BIGINT;
ALTER TABLE IWA_Case MODIFY
  BusinessRuntime BIGINT;


# Changed columns of table IWA_Task
ALTER TABLE IWA_Task MODIFY
  TaskId BIGINT NOT NULL;
ALTER TABLE IWA_Task MODIFY
  CaseId BIGINT NOT NULL;
ALTER TABLE IWA_Task MODIFY
  ApplicationId BIGINT NOT NULL;
ALTER TABLE IWA_Task MODIFY
  ProcessModelId BIGINT NOT NULL;
ALTER TABLE IWA_Task MODIFY
  StartTaskSwitchEventId BIGINT NOT NULL;
ALTER TABLE IWA_Task MODIFY
  EndTaskSwitchEventId BIGINT;
ALTER TABLE IWA_Task MODIFY
  TaskStartId BIGINT NOT NULL;
ALTER TABLE IWA_Task MODIFY
  TaskEndId BIGINT;
ALTER TABLE IWA_Task MODIFY
  WorkerUserId BIGINT;
ALTER TABLE IWA_Task MODIFY
  ActivatorRoleId BIGINT;
ALTER TABLE IWA_Task MODIFY
  ActivatorUserId BIGINT;
ALTER TABLE IWA_Task MODIFY
  ExpiryActivatorRoleId BIGINT;
ALTER TABLE IWA_Task MODIFY
  ExpiryActivatorUserId BIGINT;
ALTER TABLE IWA_Task MODIFY
  ExpiredCreatorTaskId BIGINT;
ALTER TABLE IWA_Task MODIFY
  TimeoutedCreatorIntrmdtEventId BIGINT;
ALTER TABLE IWA_Task MODIFY
  BusinessCalendarId BIGINT;
ALTER TABLE IWA_Task MODIFY
  WorkingTime BIGINT;
ALTER TABLE IWA_Task MODIFY
  BusinessRuntime BIGINT;


# Changed columns of table IWA_TaskData
ALTER TABLE IWA_TaskData MODIFY
  TaskId BIGINT NOT NULL;


# Changed columns of table IWA_StartTaskData
ALTER TABLE IWA_StartTaskData MODIFY
  TaskSwitchEventId BIGINT NOT NULL;


# Changed columns of table IWA_WorkflowEvent
ALTER TABLE IWA_WorkflowEvent MODIFY
  WorkflowEventId BIGINT NOT NULL;
ALTER TABLE IWA_WorkflowEvent MODIFY
  ApplicationId BIGINT NOT NULL;
ALTER TABLE IWA_WorkflowEvent MODIFY
  CaseId BIGINT NOT NULL;
ALTER TABLE IWA_WorkflowEvent MODIFY
  TaskId BIGINT;
ALTER TABLE IWA_WorkflowEvent MODIFY
  UserId BIGINT;


# Changed columns of table IWA_IntermediateEvent
ALTER TABLE IWA_IntermediateEvent MODIFY
  IntermediateEventId BIGINT NOT NULL;
ALTER TABLE IWA_IntermediateEvent MODIFY
  TaskStartId BIGINT NOT NULL;
ALTER TABLE IWA_IntermediateEvent MODIFY
  ApplicationId BIGINT NOT NULL;
ALTER TABLE IWA_IntermediateEvent MODIFY
  TaskId BIGINT;


# Changed columns of table IWA_IntermediateEventData
ALTER TABLE IWA_IntermediateEventData MODIFY
  IntermediateEventId BIGINT NOT NULL;


# Changed columns of table IWA_EventLog
ALTER TABLE IWA_EventLog MODIFY
  EventLogId BIGINT NOT NULL;


# Changed columns of table IWA_EventLogData
ALTER TABLE IWA_EventLogData MODIFY
  EventLogId BIGINT NOT NULL;


# Changed columns of table IWA_EventLogTaskHistory
ALTER TABLE IWA_EventLogTaskHistory MODIFY
  TaskId BIGINT NOT NULL;
ALTER TABLE IWA_EventLogTaskHistory MODIFY
  CaseId BIGINT NOT NULL;
ALTER TABLE IWA_EventLogTaskHistory MODIFY
  EventLogId BIGINT NOT NULL;


# Changed columns of table IWA_EventLogCaseHistory
ALTER TABLE IWA_EventLogCaseHistory MODIFY
  CaseId BIGINT NOT NULL;


# Changed columns of table IWA_EventLogStatus
ALTER TABLE IWA_EventLogStatus MODIFY
  EventLogId BIGINT NOT NULL;


# Changed columns of table IWA_Note
ALTER TABLE IWA_Note MODIFY
  NoteId BIGINT NOT NULL;
ALTER TABLE IWA_Note MODIFY
  UserId BIGINT;


# Changed columns of table IWA_TaskNote
ALTER TABLE IWA_TaskNote MODIFY
  TaskId BIGINT NOT NULL;
ALTER TABLE IWA_TaskNote MODIFY
  NoteId BIGINT NOT NULL;


# Changed columns of table IWA_CaseNote
ALTER TABLE IWA_CaseNote MODIFY
  CaseId BIGINT NOT NULL;
ALTER TABLE IWA_CaseNote MODIFY
  NoteId BIGINT NOT NULL;


# Changed columns of table IWA_AdditionalProperty
ALTER TABLE IWA_AdditionalProperty MODIFY
  AdditionalPropertyId BIGINT NOT NULL;


# Changed columns of table IWA_TaskAdditionalProperty
ALTER TABLE IWA_TaskAdditionalProperty MODIFY
  TaskId BIGINT NOT NULL;
ALTER TABLE IWA_TaskAdditionalProperty MODIFY
  AdditionalPropertyId BIGINT NOT NULL;


# Changed columns of table IWA_CaseAdditionalProperty
ALTER TABLE IWA_CaseAdditionalProperty MODIFY
  CaseId BIGINT NOT NULL;
ALTER TABLE IWA_CaseAdditionalProperty MODIFY
  AdditionalPropertyId BIGINT NOT NULL;


# Changed columns of table IWA_PageArchive
ALTER TABLE IWA_PageArchive MODIFY
  PageArchiveId BIGINT NOT NULL;
ALTER TABLE IWA_PageArchive MODIFY
  UserId BIGINT;
ALTER TABLE IWA_PageArchive MODIFY
  PageElementId BIGINT NOT NULL;
ALTER TABLE IWA_PageArchive MODIFY
  TaskId BIGINT NOT NULL;


# Changed columns of table IWA_ContentManagementSystem
ALTER TABLE IWA_ContentManagementSystem MODIFY
  ContentManagementSystemId BIGINT NOT NULL;
ALTER TABLE IWA_ContentManagementSystem MODIFY
  ApplicationId BIGINT NOT NULL;
ALTER TABLE IWA_ContentManagementSystem MODIFY
  ProcessModelVersionId BIGINT NOT NULL;
ALTER TABLE IWA_ContentManagementSystem MODIFY
  DefaultPageLayoutId BIGINT;
ALTER TABLE IWA_ContentManagementSystem MODIFY
  DefaultPageStyleSheetId BIGINT;


# Changed columns of table IWA_Language
ALTER TABLE IWA_Language MODIFY
  LanguageId BIGINT NOT NULL;


# Changed columns of table IWA_SupportedLanguage
ALTER TABLE IWA_SupportedLanguage MODIFY
  SupportedLanguageId BIGINT NOT NULL;
ALTER TABLE IWA_SupportedLanguage MODIFY
  ContentManagementSystemId BIGINT NOT NULL;


# Changed columns of table IWA_ContentObjectType
ALTER TABLE IWA_ContentObjectType MODIFY
  ContentObjectTypeId BIGINT NOT NULL;


# Changed columns of table IWA_ContentObject
ALTER TABLE IWA_ContentObject MODIFY
  ContentObjectId BIGINT NOT NULL;
ALTER TABLE IWA_ContentObject MODIFY
  ParentContentObjectId BIGINT;
ALTER TABLE IWA_ContentObject MODIFY
  ContentObjectTypeId BIGINT NOT NULL;
ALTER TABLE IWA_ContentObject MODIFY
  ContentManagementSystemId BIGINT NOT NULL;


# Changed columns of table IWA_StartPage
ALTER TABLE IWA_StartPage MODIFY
  StartPageId BIGINT NOT NULL;
ALTER TABLE IWA_StartPage MODIFY
  ContentObjectId BIGINT;
ALTER TABLE IWA_StartPage MODIFY
  ContentManagementSystemId BIGINT NOT NULL;


# Changed columns of table IWA_ContentObjectValue
ALTER TABLE IWA_ContentObjectValue MODIFY
  ContentObjectValueId BIGINT NOT NULL;
ALTER TABLE IWA_ContentObjectValue MODIFY
  ContentObjectId BIGINT NOT NULL;


# Changed columns of table IWA_ContentDataString
ALTER TABLE IWA_ContentDataString MODIFY
  ContentObjectValueId BIGINT NOT NULL;


# Changed columns of table IWA_ContentDataInteger
ALTER TABLE IWA_ContentDataInteger MODIFY
  ContentObjectValueId BIGINT NOT NULL;


# Changed columns of table IWA_ContentDataFloat
ALTER TABLE IWA_ContentDataFloat MODIFY
  ContentObjectValueId BIGINT NOT NULL;


# Changed columns of table IWA_ContentDataDateTime
ALTER TABLE IWA_ContentDataDateTime MODIFY
  ContentObjectValueId BIGINT NOT NULL;


# Changed columns of table IWA_ContentDataText
ALTER TABLE IWA_ContentDataText MODIFY
  ContentObjectValueId BIGINT NOT NULL;


# Changed columns of table IWA_ContentDataImage
ALTER TABLE IWA_ContentDataImage MODIFY
  ContentObjectValueId BIGINT NOT NULL;


# Changed columns of table IWA_ContentDataDecimal
ALTER TABLE IWA_ContentDataDecimal MODIFY
  ContentObjectValueId BIGINT NOT NULL;


# Changed columns of table IWA_SecurityDescriptor
ALTER TABLE IWA_SecurityDescriptor MODIFY
  SecurityDescriptorId BIGINT NOT NULL;
ALTER TABLE IWA_SecurityDescriptor MODIFY
  SecurityDescriptorTypeId BIGINT NOT NULL;
ALTER TABLE IWA_SecurityDescriptor MODIFY
  OwnerUserId BIGINT;


# Changed columns of table IWA_PermissionGroup
ALTER TABLE IWA_PermissionGroup MODIFY
  PermissionGroupId BIGINT NOT NULL;
ALTER TABLE IWA_PermissionGroup MODIFY
  ParentPermissionGroupId BIGINT;


# Changed columns of table IWA_SecurityDescriptorType
ALTER TABLE IWA_SecurityDescriptorType MODIFY
  SecurityDescriptorTypeId BIGINT NOT NULL;
ALTER TABLE IWA_SecurityDescriptorType MODIFY
  RootPermissionGroupId BIGINT NOT NULL;


# Changed columns of table IWA_AccessControl
ALTER TABLE IWA_AccessControl MODIFY
  AccessControlId BIGINT NOT NULL;
ALTER TABLE IWA_AccessControl MODIFY
  SecurityDescriptorId BIGINT NOT NULL;
ALTER TABLE IWA_AccessControl MODIFY
  PermissionId BIGINT NOT NULL;
ALTER TABLE IWA_AccessControl MODIFY
  RoleId BIGINT;
ALTER TABLE IWA_AccessControl MODIFY
  UserId BIGINT;


# Changed columns of table IWA_Permission
ALTER TABLE IWA_Permission MODIFY
  PermissionId BIGINT NOT NULL;


# Changed columns of table IWA_PermissionGroupPermission
ALTER TABLE IWA_PermissionGroupPermission MODIFY
  PermissionGroupId BIGINT NOT NULL;
ALTER TABLE IWA_PermissionGroupPermission MODIFY
  PermissionId BIGINT NOT NULL;


# Changed columns of table IWA_UploadedFile
ALTER TABLE IWA_UploadedFile MODIFY
  FileId BIGINT NOT NULL;

ALTER TABLE IWA_WebService ADD
(
 FOREIGN KEY (ApplicationId) REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE
);

ALTER TABLE IWA_WebServiceEnvironment ADD
(
 FOREIGN KEY (ApplicationId) REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE
);

ALTER TABLE IWA_BusinessCalendar ADD
(
 FOREIGN KEY (ApplicationId) REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE
);

ALTER TABLE IWA_Library ADD
(
 FOREIGN KEY (ApplicationId) REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE
);

ALTER TABLE IWA_WebServiceEnvironment ADD
(
 FOREIGN KEY (EnvironmentId) REFERENCES IWA_Environment(EnvironmentId) ON DELETE CASCADE
);

ALTER TABLE IWA_Case ADD
(
 FOREIGN KEY (EnvironmentId) REFERENCES IWA_Environment(EnvironmentId) ON DELETE SET NULL
);

ALTER TABLE IWA_GlobalVariable ADD
(
 FOREIGN KEY (ParentGlobalVariableId) REFERENCES IWA_GlobalVariable(GlobalVariableId) ON DELETE CASCADE
);

ALTER TABLE IWA_WebServiceEnvironment ADD
(
 FOREIGN KEY (WebServiceId) REFERENCES IWA_WebService(WebServiceId) ON DELETE CASCADE
);

ALTER TABLE IWA_WebServicePortType ADD
(
 FOREIGN KEY (WebServiceId) REFERENCES IWA_WebService(WebServiceId) ON DELETE CASCADE
);

ALTER TABLE IWA_WebServiceEndpoint ADD
(
 FOREIGN KEY (WebServiceEnvironmentId) REFERENCES IWA_WebServiceEnvironment(WebServiceEnvironmentId) ON DELETE CASCADE
);

ALTER TABLE IWA_WebServiceEndpoint ADD
(
 FOREIGN KEY (WebServicePortTypeId) REFERENCES IWA_WebServicePortType(WebServicePortTypeId) ON DELETE CASCADE
);

ALTER TABLE IWA_Application ADD
(
 FOREIGN KEY (BusinessCalendarId) REFERENCES IWA_BusinessCalendar(BusinessCalendarId) ON DELETE SET NULL
);

ALTER TABLE IWA_Environment ADD
(
 FOREIGN KEY (BusinessCalendarId) REFERENCES IWA_BusinessCalendar(BusinessCalendarId) ON DELETE SET NULL
);

ALTER TABLE IWA_BusinessCalendar ADD
(
 FOREIGN KEY (ParentCalendarId) REFERENCES IWA_BusinessCalendar(BusinessCalendarId) ON DELETE CASCADE
);

ALTER TABLE IWA_Case ADD
(
 FOREIGN KEY (BusinessCalendarId) REFERENCES IWA_BusinessCalendar(BusinessCalendarId) ON DELETE SET NULL
);

ALTER TABLE IWA_Task ADD
(
 FOREIGN KEY (BusinessCalendarId) REFERENCES IWA_BusinessCalendar(BusinessCalendarId) ON DELETE SET NULL
);

ALTER TABLE IWA_ExternalDatabase ADD
(
 FOREIGN KEY (ParentExternalDatabaseId) REFERENCES IWA_ExternalDatabase(ExternalDatabaseId) ON DELETE CASCADE
);

ALTER TABLE IWA_Library ADD
(
 FOREIGN KEY (ProcessModelVersionId) REFERENCES IWA_ProcessModelVersion(ProcessModelVersionId) ON DELETE CASCADE
);

ALTER TABLE IWA_LibrarySpecification ADD
(
 FOREIGN KEY (LibraryId) REFERENCES IWA_Library(LibraryId) ON DELETE CASCADE
);

ALTER TABLE IWA_LibrarySpecification ADD
(
 FOREIGN KEY (ResolvedLibraryId) REFERENCES IWA_Library(LibraryId) ON DELETE SET NULL
);

ALTER TABLE IWA_LibraryVersionSpec ADD
(
 FOREIGN KEY (LibrarySpecificationId) REFERENCES IWA_LibrarySpecification(LibrarySpecificationId) ON DELETE CASCADE
);

ALTER TABLE IWA_Role ADD
(
 FOREIGN KEY (ParentRoleId) REFERENCES IWA_Role(RoleId) ON DELETE CASCADE
);

ALTER TABLE IWA_WebServiceProcStartElement ADD
(
 FOREIGN KEY (WebServiceProcessId) REFERENCES IWA_WebServiceProcess(WebServiceProcessId) ON DELETE CASCADE
);

ALTER TABLE IWA_AsyncProcessCaseData ADD
(
 FOREIGN KEY (CaseId) REFERENCES IWA_Case(CaseId) ON DELETE CASCADE
);

ALTER TABLE IWA_EventLogData ADD
(
 FOREIGN KEY (EventLogId) REFERENCES IWA_EventLog(EventLogId) ON DELETE CASCADE
);

ALTER TABLE IWA_EventLogTaskHistory ADD
(
 FOREIGN KEY (EventLogId) REFERENCES IWA_EventLog(EventLogId) ON DELETE CASCADE
);

ALTER TABLE IWA_EventLogStatus ADD
(
 FOREIGN KEY (EventLogId) REFERENCES IWA_EventLog(EventLogId) ON DELETE CASCADE
);

ALTER TABLE IWA_ContentObject ADD
(
 FOREIGN KEY (ParentContentObjectId) REFERENCES IWA_ContentObject(ContentObjectId) ON DELETE CASCADE
);


# Recreate views which depend on changed tables
CREATE VIEW IWA_TaskQuery
(
  TaskId,
  CaseId,
  ProcessModelId,
  ApplicationId,
  StartTaskSwitchEventId,
  EndTaskSwitchEventId,
  TaskStartId,
  TaskEndId,
  WorkerUserId,
  WorkerUserName,
  WorkerSessionId,
  ActivatorRoleId,
  ActivatorUserId,
  ActivatorName,
  ExpiryActivatorRoleId,
  ExpiryActivatorUserId,
  ExpiryActivatorName,
  ExpiryPriority,
  ExpiryTimestamp,
  ExpiryTaskStartElementPid,
  IsExpired,
  ExpiredCreatorTaskId,
  TimeoutedCreatorIntrmdtEventId,
  DelayTimestamp,
  `State`,
  RequestPath,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  Priority,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendarId,
  WorkingTime,
  BusinessRuntime,
  FailedTimeoutTimestamp,
  NumberOfFailures,
  NumberOfResumes,
  KindCode,
  KindName,
  BusinessMilestoneTimestamp,
  CustomVarCharField1,
  CustomVarCharField2,
  CustomVarCharField3,
  CustomVarCharField4,
  CustomVarCharField5,
  CustomDecimalField1,
  CustomDecimalField2,
  CustomDecimalField3,
  CustomDecimalField4,
  CustomDecimalField5,
  CustomTimestampField1,
  CustomTimestampField2,
  CustomTimestampField3,
  CustomTimestampField4,
  CustomTimestampField5,
  IsUpdatedOnStart,
  CurrentPriority,
  CurrentActivatorName,
  CurrentActivatorRoleId,
  CurrentActivatorUserId,
  ProcessCategoryCode,
  ProcessCategoryName,
  ProcessCode,
  ProcessName,
  TypeCode,
  TypeName,
  SubTypeCode,
  SubTypeName,
  BusinessObjectCode,
  BusinessObjectName,
  BusinessMainContactId,
  BusinessMainContactName,
  BusinessStartTimestamp,
  BusinessCreatorUser
)
AS
  SELECT
    IWA_Task.TaskId,
    IWA_Task.CaseId,
    IWA_Task.ProcessModelId,
    IWA_Task.ApplicationId,
    IWA_Task.StartTaskSwitchEventId,
    IWA_Task.EndTaskSwitchEventId,
    IWA_Task.TaskStartId,
    IWA_Task.TaskEndId,
    IWA_Task.WorkerUserId,
    IWA_Task.WorkerUserName,
    IWA_Task.WorkerSessionId,
    IWA_Task.ActivatorRoleId,
    IWA_Task.ActivatorUserId,
    IWA_Task.ActivatorName,
    IWA_Task.ExpiryActivatorRoleId,
    IWA_Task.ExpiryActivatorUserId,
    IWA_Task.ExpiryActivatorName,
    IWA_Task.ExpiryPriority,
    IWA_Task.ExpiryTimestamp,
    IWA_Task.ExpiryTaskStartElementPid,
    IWA_Task.IsExpired,
    IWA_Task.ExpiredCreatorTaskId,
    IWA_Task.TimeoutedCreatorIntrmdtEventId,
    IWA_Task.DelayTimestamp,
    IWA_Task.`State`,
    IWA_Task.RequestPath,
    IWA_Task.DisplayNameTemplate,
    IWA_Task.Name,
    IWA_Task.DisplayDescriptionTemplate,
    IWA_Task.Description,
    IWA_Task.Priority,
    IWA_Task.StartTimestamp,
    IWA_Task.EndTimestamp,
    IWA_Task.BusinessCalendarId,
    IWA_Task.WorkingTime,
    IWA_Task.BusinessRuntime,
    IWA_Task.FailedTimeoutTimestamp,
    IWA_Task.NumberOfFailures,
    IWA_Task.NumberOfResumes,
    IWA_Task.KindCode,
    IWA_Task.KindName,
    IWA_Task.BusinessMilestoneTimestamp,
    IWA_Task.CustomVarCharField1,
    IWA_Task.CustomVarCharField2,
    IWA_Task.CustomVarCharField3,
    IWA_Task.CustomVarCharField4,
    IWA_Task.CustomVarCharField5,
    IWA_Task.CustomDecimalField1,
    IWA_Task.CustomDecimalField2,
    IWA_Task.CustomDecimalField3,
    IWA_Task.CustomDecimalField4,
    IWA_Task.CustomDecimalField5,
    IWA_Task.CustomTimestampField1,
    IWA_Task.CustomTimestampField2,
    IWA_Task.CustomTimestampField3,
    IWA_Task.CustomTimestampField4,
    IWA_Task.CustomTimestampField5,
    IWA_Task.IsUpdatedOnStart,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryPriority WHEN 0 THEN IWA_Task.Priority END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorName WHEN 0 THEN IWA_Task.ActivatorName END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorRoleId WHEN 0 THEN IWA_Task.ActivatorRoleId END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorUserId WHEN 0 THEN IWA_Task.ActivatorUserId END,
    IWA_Case.ProcessCategoryCode,
    IWA_Case.ProcessCategoryName,
    IWA_Case.ProcessCode,
    IWA_Case.ProcessName,
    IWA_Case.TypeCode,
    IWA_Case.TypeName,
    IWA_Case.SubTypeCode,
    IWA_Case.SubTypeName,
    IWA_Case.BusinessObjectCode,
    IWA_Case.BusinessObjectName,
    IWA_Case.BusinessMainContactId,
    IWA_Case.BusinessMainContactName,
    IWA_Case.BusinessStartTimestamp,
    IWA_Case.BusinessCreatorUser
  FROM IWA_Task, IWA_Case
  WHERE IWA_Task.CaseId = IWA_Case.CaseId;

CREATE VIEW IWA_ProcessStart
(
  TaskElementId,
  ProcessModelVersionId,
  Name,
  Description,
  ProcessElementId,
  TaskStartId,
  StartRequestPath,
  UserFriendlyStartRequestPath,
  ActivatorRoleId
)
AS
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_StartElement.ActivatorRoleId
  FROM IWA_TaskElement, IWA_TaskStart, IWA_StartElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_StartElement.TaskStartId
UNION ALL
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_StartEventElement.ActivatorRoleId
  FROM IWA_TaskElement, IWA_TaskStart, IWA_StartEventElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_StartEventElement.TaskStartId
UNION ALL
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_WebServiceProcStartElement.ActivatorRoleId
  FROM IWA_TaskElement, IWA_TaskStart, IWA_WebServiceProcStartElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_WebServiceProcStartElement.TaskStartId;

# Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;

ALTER TABLE IWA_Identifier MODIFY
  IdentifierValue BIGINT NOT NULL;

# Drop temporary created stored procedures needed for conversion
DROP PROCEDURE IWA_Drop_ForeignKey_Constraint;

# 
# Update Version
# 
UPDATE IWA_Version SET Version=33;
