# ---------------------------------------------------------------------------------
# 
# Converts the ivy system database from version 52 to version 53
# 
# ---------------------------------------------------------------------------------
# 
# This script was automatically generated. Do not edit it. Instead edit the source file
# 
# ---------------------------------------------------------------------------------
# Database: MySQL
# ---------------------------------------------------------------------------------
# Copyright:
# Axon Ivy AG, Baarerstrasse 12, 6300 Zug
# ---------------------------------------------------------------------------------


# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_CaseDeleteTrigger;

# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_TaskDeleteTrigger;

# Drop trigger of no longer exisiting table
DROP TRIGGER IWA_TaskAdditionalPropertyDeleteTrigger;

# Drop trigger of no longer exisiting table
DROP TRIGGER IWA_CaseAdditionalPropertyDeleteTrigger;

# Drop no longer exisiting table
DROP TABLE IWA_TaskAdditionalProperty;

# Drop no longer exisiting table
DROP TABLE IWA_CaseAdditionalProperty;

# Drop no longer exisiting table
DROP TABLE IWA_AdditionalProperty;

# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_CaseDeleteTrigger
AFTER DELETE ON IWA_Case
FOR EACH ROW
BEGIN
  DELETE FROM IWA_TaskSwitchEvent
  WHERE IWA_TaskSwitchEvent.CaseId = OLD.CaseId;

  DELETE FROM IWA_Task
  WHERE IWA_Task.CaseId = OLD.CaseId;

  DELETE FROM IWA_WorkflowEvent
  WHERE IWA_WorkflowEvent.CaseId = OLD.CaseId;

  DELETE FROM IWA_CaseNote
  WHERE IWA_CaseNote.CaseId = OLD.CaseId;

END
;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_TaskDeleteTrigger
AFTER DELETE ON IWA_Task
FOR EACH ROW
BEGIN
  DELETE FROM IWA_TaskData
  WHERE IWA_TaskData.TaskId = OLD.TaskId;

  DELETE FROM IWA_WorkflowEvent
  WHERE IWA_WorkflowEvent.TaskId = OLD.TaskId;

  DELETE FROM IWA_IntermediateEvent
  WHERE IWA_IntermediateEvent.TaskId = OLD.TaskId;

  DELETE FROM IWA_TaskNote
  WHERE IWA_TaskNote.TaskId = OLD.TaskId;

  DELETE FROM IWA_TaskLocation
  WHERE IWA_TaskLocation.TaskId = OLD.TaskId;

  DELETE FROM IWA_TaskSignalEventReceiver
  WHERE IWA_TaskSignalEventReceiver.WaitingTaskId = OLD.TaskId;

  DELETE FROM IWA_SignaledTask
  WHERE IWA_SignaledTask.SignaledTaskId = OLD.TaskId;

  UPDATE IWA_SignalEvent
  SET SentByTaskId=NULL
  WHERE IWA_SignalEvent.SentByTaskId=OLD.TaskId;

  DELETE FROM IWA_PageArchive
  WHERE IWA_PageArchive.TaskId = OLD.TaskId;

END
;

# Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


# 
# Update Version
# 
UPDATE IWA_Version SET Version=53;
