-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 44 to version 45
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Oracle
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Create new added tables
CREATE TABLE IWA_CaseMap
(
  CaseMapId NUMBER(20) NOT NULL,
  ProcessModelVersionId NUMBER(20) NOT NULL REFERENCES IWA_ProcessModelVersion(ProcessModelVersionId) ON DELETE CASCADE,
  ApplicationId NUMBER(20) NOT NULL REFERENCES IWA_Application(ApplicationId),
  UUID VARCHAR2(36) NOT NULL,
  Name VARCHAR2(200) NOT NULL,
  Model CLOB NOT NULL,
  PRIMARY KEY (CaseMapId),
  UNIQUE (ProcessModelVersionId, UUID)
)
TABLESPACE ${tablespaceName};

CREATE TABLE IWA_CaseMapBusinessCase
(
  BusinessCaseId NUMBER(20) NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  CaseMapId NUMBER(20) NOT NULL REFERENCES IWA_CaseMap(CaseMapId) ON DELETE CASCADE,
  PRIMARY KEY (BusinessCaseId)
)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_CaseMapBusCase_CsMpIdIdx
ON IWA_CaseMapBusinessCase (CaseMapId)
TABLESPACE ${tablespaceName};

CREATE TABLE IWA_CaseMapEvent
(
  CaseMapEventId NUMBER(20) NOT NULL,
  BusinessCaseId NUMBER(20) NOT NULL REFERENCES IWA_CaseMapBusinessCase(BusinessCaseId) ON DELETE CASCADE,
  "TIMESTAMP" DATE NOT NULL,
  Kind NUMBER(10) NOT NULL,
  Stage VARCHAR2(200) NOT NULL,
  Process VARCHAR2(200) NOT NULL,
  ProcessCaseId NUMBER(20) REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Milestone VARCHAR2(200) NOT NULL,
  Reason VARCHAR2(200) NOT NULL,
  ProcessingState NUMBER(10) NOT NULL,
  ProcessingErrorMessage VARCHAR2(750) NOT NULL,
  ProcessingErrorCount NUMBER(10) NOT NULL,
  ProcessingRetryTimestamp DATE,
  PRIMARY KEY (CaseMapEventId)
)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_CaseMapEvent_BcId
ON IWA_CaseMapEvent (BusinessCaseId)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_CaseMapEvent_PrcRtryTstmp
ON IWA_CaseMapEvent (ProcessingRetryTimestamp)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_CaseMapEvent_PrcState
ON IWA_CaseMapEvent (ProcessingState)
TABLESPACE ${tablespaceName};

CREATE TABLE IWA_BusinessCaseData
(
  BusinessDataId VARCHAR2(100) NOT NULL,
  ObjectType VARCHAR2(255) NOT NULL,
  BusinessCaseId NUMBER(20) NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  PRIMARY KEY (BusinessDataId),
  UNIQUE (BusinessCaseId, ObjectType)
)
TABLESPACE ${tablespaceName};

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=45;
