-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 35 to version 36
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Postgre SQL
-- ---------------------------------------------------------------------------------
-- Copyright:
-- ivyTeam AG, Alpenstrasse 9, 6304 Zug
-- ---------------------------------------------------------------------------------


-- Create new added tables
CREATE TABLE IWA_TaskSignalEventReceiver
(
  TaskSignalEventId BIGINT NOT NULL,
  WaitingTaskId BIGINT NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  SignalCodePattern VARCHAR(200) NOT NULL,
  SignaledTaskTaskStartId BIGINT NOT NULL REFERENCES IWA_TaskStart(TaskStartId) ON DELETE CASCADE,
  StartedSignaledTaskId BIGINT,
  PRIMARY KEY (TaskSignalEventId)
);

CREATE INDEX IWA_TskSigEvntRcvr_WtingTaskId
ON IWA_TaskSignalEventReceiver (WaitingTaskId);

CREATE INDEX IWA_TskSigEvntRcvr_StrtSgTskId
ON IWA_TaskSignalEventReceiver (StartedSignaledTaskId);

CREATE TABLE IWA_SignaledTask
(
  SignaledTaskId BIGINT NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  SignalCodePattern VARCHAR(200) NOT NULL,
  ReceivedSignalEventId BIGINT,
  PRIMARY KEY (SignaledTaskId)
);

CREATE INDEX IWA_SigTask_RecvdSignalEventId
ON IWA_SignaledTask (ReceivedSignalEventId);

CREATE TABLE IWA_SignalEvent
(
  SignalEventId BIGINT NOT NULL,
  ApplicationId BIGINT NOT NULL REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE,
  SignalCode VARCHAR(200) NOT NULL,
  SentTimestamp TIMESTAMP NOT NULL,
  SentByUserName VARCHAR(200),
  SentByUserId BIGINT REFERENCES IWA_User(UserId) ON DELETE SET NULL,
  SentByTaskId BIGINT REFERENCES IWA_Task(TaskId) ON DELETE SET NULL,
  SentByProcessElementPid VARCHAR(200),
  PRIMARY KEY (SignalEventId)
);

CREATE INDEX IWA_SignalEvent_SignalCode
ON IWA_SignalEvent (SignalCode);

CREATE INDEX IWA_SignalEvent_SentTimestamp
ON IWA_SignalEvent (SentTimestamp);

CREATE INDEX IWA_SignalEvent_SentByTaskId
ON IWA_SignalEvent (SentByTaskId);

CREATE INDEX IWA_SignalEvent_SentByUserId
ON IWA_SignalEvent (SentByUserId);

CREATE TABLE IWA_SignalEventData
(
  SignalEventId BIGINT NOT NULL REFERENCES IWA_SignalEvent(SignalEventId) ON DELETE CASCADE,
  SignalData BYTEA NOT NULL,
  PRIMARY KEY (SignalEventId)
);

CREATE TABLE IWA_StartSignalEventElement
(
  TaskStartId BIGINT NOT NULL REFERENCES IWA_TaskStart(TaskStartId) ON DELETE CASCADE,
  SignalCodePattern VARCHAR(200) NOT NULL,
  PRIMARY KEY (TaskStartId)
);

CREATE INDEX IWA_StrtSigEvntElmnt_SgCdPttrn
ON IWA_StartSignalEventElement (SignalCodePattern);

ALTER TABLE IWA_TaskSignalEventReceiver ADD FOREIGN KEY (StartedSignaledTaskId) REFERENCES IWA_SignaledTask(SignaledTaskId) ON DELETE SET NULL;

ALTER TABLE IWA_SignaledTask ADD FOREIGN KEY (ReceivedSignalEventId) REFERENCES IWA_SignalEvent(SignalEventId) ON DELETE SET NULL;


-- Changed columns of table IWA_Library
ALTER TABLE IWA_Library ALTER COLUMN Version TYPE VARCHAR(50);
ALTER TABLE IWA_Library ALTER COLUMN Version SET DEFAULT '';


-- Changed columns of table IWA_LibraryVersionSpec
ALTER TABLE IWA_LibraryVersionSpec ALTER COLUMN Version TYPE VARCHAR(50);
ALTER TABLE IWA_LibraryVersionSpec ALTER COLUMN Version SET DEFAULT '';


-- Create new indexes of table IWA_UserLocation
CREATE INDEX IWA_UserLocation_UserId
ON IWA_UserLocation (UserId);


-- Create new indexes of table IWA_TaskLocation
CREATE INDEX IWA_TaskLocation_TaskId
ON IWA_TaskLocation (TaskId);

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=36;
